
; GL types

GLenum	   fix dd
GLboolean  fix db
GLbitfield fix dd
GLbyte	   fix db
GLshort    fix dw
GLint	   fix dd
GLsizei    fix dd
GLubyte    fix db
GLushort   fix dw
GLuint	   fix dd
GLfloat    fix dd
GLclampf   fix dd
GLdouble   fix dq
GLclampd   fix dq

; GL errors

GL_NO_ERROR	     = 0
GL_INVALID_ENUM      = $0500
GL_INVALID_VALUE     = $0501
GL_INVALID_OPERATION = $0502
GL_STACK_OVERFLOW    = $0503
GL_STACK_UNDERFLOW   = $0504
GL_OUT_OF_MEMORY     = $0505

; Attribute bits

GL_CURRENT_BIT	       = $00000001
GL_POINT_BIT	       = $00000002
GL_LINE_BIT	       = $00000004
GL_POLYGON_BIT	       = $00000008
GL_POLYGON_STIPPLE_BIT = $00000010
GL_PIXEL_MODE_BIT      = $00000020
GL_LIGHTING_BIT        = $00000040
GL_FOG_BIT	       = $00000080
GL_DEPTH_BUFFER_BIT    = $00000100
GL_ACCUM_BUFFER_BIT    = $00000200
GL_STENCIL_BUFFER_BIT  = $00000400
GL_VIEWPORT_BIT        = $00000800
GL_TRANSFORM_BIT       = $00001000
GL_ENABLE_BIT	       = $00002000
GL_COLOR_BUFFER_BIT    = $00004000
GL_HINT_BIT	       = $00008000
GL_EVAL_BIT	       = $00010000
GL_LIST_BIT	       = $00020000
GL_TEXTURE_BIT	       = $00040000
GL_SCISSOR_BIT	       = $00080000
GL_ALL_ATTRIB_BITS     = $000FFFFF

; Client attribute bits

GL_CLIENT_PIXEL_STORE_BIT  = $00000001
GL_CLIENT_VERTEX_ARRAY_BIT = $00000002
GL_CLIENT_ALL_ATTRIB_BITS  = $FFFFFFFF

; Boolean values

GL_FALSE = 0
GL_TRUE  = 1

; Primitives

GL_POINTS	  = $0000
GL_LINES	  = $0001
GL_LINE_LOOP	  = $0002
GL_LINE_STRIP	  = $0003
GL_TRIANGLES	  = $0004
GL_TRIANGLE_STRIP = $0005
GL_TRIANGLE_FAN   = $0006
GL_QUADS	  = $0007
GL_QUAD_STRIP	  = $0008
GL_POLYGON	  = $0009

; Blending

GL_ZERO 	       = 0
GL_ONE		       = 1
GL_SRC_COLOR	       = $0300
GL_ONE_MINUS_SRC_COLOR = $0301
GL_SRC_ALPHA	       = $0302
GL_ONE_MINUS_SRC_ALPHA = $0303
GL_DST_ALPHA	       = $0304
GL_ONE_MINUS_DST_ALPHA = $0305
GL_DST_COLOR	       = $0306
GL_ONE_MINUS_DST_COLOR = $0307
GL_SRC_ALPHA_SATURATE  = $0308
GL_BLEND_DST	       = $0BE0
GL_BLEND_SRC	       = $0BE1
GL_BLEND	       = $0BE2

; Blending (GL 1.2 ARB imaging)

GL_BLEND_COLOR		    = $8005
GL_CONSTANT_COLOR	    = $8001
GL_ONE_MINUS_CONSTANT_COLOR = $8002
GL_CONSTANT_ALPHA	    = $8003
GL_ONE_MINUS_CONSTANT_ALPHA = $8004
GL_FUNC_ADD		    = $8006
GL_MIN			    = $8007
GL_MAX			    = $8008
GL_FUNC_SUBTRACT	    = $800A
GL_FUNC_REVERSE_SUBTRACT    = $800B

; Color table (GL 1.2 ARB imaging)

GL_COLOR_TABLE			       = $80D0
GL_POST_CONVOLUTION_COLOR_TABLE        = $80D1
GL_POST_COLOR_MATRIX_COLOR_TABLE       = $80D2
GL_PROXY_COLOR_TABLE		       = $80D3
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE  = $80D4
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = $80D5
GL_COLOR_TABLE_SCALE		       = $80D6
GL_COLOR_TABLE_BIAS		       = $80D7
GL_COLOR_TABLE_FORMAT		       = $80D8
GL_COLOR_TABLE_WIDTH		       = $80D9
GL_COLOR_TABLE_RED_SIZE 	       = $80DA
GL_COLOR_TABLE_GREEN_SIZE	       = $80DB
GL_COLOR_TABLE_BLUE_SIZE	       = $80DC
GL_COLOR_TABLE_ALPHA_SIZE	       = $80DD
GL_COLOR_TABLE_LUMINANCE_SIZE	       = $80DE
GL_COLOR_TABLE_INTENSITY_SIZE	       = $80DF

; Convolutions (GL 1.2 ARB imaging)

GL_CONVOLUTION_1D		= $8010
GL_CONVOLUTION_2D		= $8011
GL_SEPARABLE_2D 		= $8012
GL_CONVOLUTION_BORDER_MODE	= $8013
GL_CONVOLUTION_FILTER_SCALE	= $8014
GL_CONVOLUTION_FILTER_BIAS	= $8015
GL_REDUCE			= $8016
GL_CONVOLUTION_FORMAT		= $8017
GL_CONVOLUTION_WIDTH		= $8018
GL_CONVOLUTION_HEIGHT		= $8019
GL_MAX_CONVOLUTION_WIDTH	= $801A
GL_MAX_CONVOLUTION_HEIGHT	= $801B
GL_POST_CONVOLUTION_RED_SCALE	= $801C
GL_POST_CONVOLUTION_GREEN_SCALE = $801D
GL_POST_CONVOLUTION_BLUE_SCALE	= $801E
GL_POST_CONVOLUTION_ALPHA_SCALE = $801F
GL_POST_CONVOLUTION_RED_BIAS	= $8020
GL_POST_CONVOLUTION_GREEN_BIAS	= $8021
GL_POST_CONVOLUTION_BLUE_BIAS	= $8022
GL_POST_CONVOLUTION_ALPHA_BIAS	= $8023

; Histogram (GL 1.2 ARB imaging)

GL_HISTOGRAM		    = $8024
GL_PROXY_HISTOGRAM	    = $8025
GL_HISTOGRAM_WIDTH	    = $8026
GL_HISTOGRAM_FORMAT	    = $8027
GL_HISTOGRAM_RED_SIZE	    = $8028
GL_HISTOGRAM_GREEN_SIZE     = $8029
GL_HISTOGRAM_BLUE_SIZE	    = $802A
GL_HISTOGRAM_ALPHA_SIZE     = $802B
GL_HISTOGRAM_LUMINANCE_SIZE = $802C
GL_HISTOGRAM_SINK	    = $802D
GL_MINMAX		    = $802E
GL_MINMAX_FORMAT	    = $802F
GL_MINMAX_SINK		    = $8030

; Buffers

GL_NONE 	  = 0
GL_FRONT_LEFT	  = $0400
GL_FRONT_RIGHT	  = $0401
GL_BACK_LEFT	  = $0402
GL_BACK_RIGHT	  = $0403
GL_FRONT	  = $0404
GL_BACK 	  = $0405
GL_LEFT 	  = $0406
GL_RIGHT	  = $0407
GL_FRONT_AND_BACK = $0408
GL_AUX0 	  = $0409
GL_AUX1 	  = $040A
GL_AUX2 	  = $040B
GL_AUX3 	  = $040C
GL_AUX_BUFFERS	  = $0C00
GL_DRAW_BUFFER	  = $0C01
GL_READ_BUFFER	  = $0C02
GL_DOUBLEBUFFER   = $0C32
GL_STEREO	  = $0C33

; Depth buffer

GL_DEPTH_RANGE	     = $0B70
GL_DEPTH_TEST	     = $0B71
GL_DEPTH_WRITEMASK   = $0B72
GL_DEPTH_CLEAR_VALUE = $0B73
GL_DEPTH_FUNC	     = $0B74
GL_NEVER	     = $0200
GL_LESS 	     = $0201
GL_EQUAL	     = $0202
GL_LEQUAL	     = $0203
GL_GREATER	     = $0204
GL_NOTEQUAL	     = $0205
GL_GEQUAL	     = $0206
GL_ALWAYS	     = $0207

; Accumulation buffer

GL_ACCUM	     = $0100
GL_LOAD 	     = $0101
GL_RETURN	     = $0102
GL_MULT 	     = $0103
GL_ADD		     = $0104
GL_ACCUM_CLEAR_VALUE = $0B80

; Feedback buffer

GL_FEEDBACK_BUFFER_POINTER = $0DF0
GL_FEEDBACK_BUFFER_SIZE    = $0DF1
GL_FEEDBACK_BUFFER_TYPE    = $0DF2

; Feedback types

GL_2D		    = $0600
GL_3D		    = $0601
GL_3D_COLOR	    = $0602
GL_3D_COLOR_TEXTURE = $0603
GL_4D_COLOR_TEXTURE = $0604

; Feedback tokens

GL_PASS_THROUGH_TOKEN = $0700
GL_POINT_TOKEN	      = $0701
GL_LINE_TOKEN	      = $0702
GL_POLYGON_TOKEN      = $0703
GL_BITMAP_TOKEN       = $0704
GL_DRAW_PIXEL_TOKEN   = $0705
GL_COPY_PIXEL_TOKEN   = $0706
GL_LINE_RESET_TOKEN   = $0707

; Fog

GL_EXP	       = $0800
GL_EXP2        = $0801
GL_FOG	       = $0B60
GL_FOG_INDEX   = $0B61
GL_FOG_DENSITY = $0B62
GL_FOG_START   = $0B63
GL_FOG_END     = $0B64
GL_FOG_MODE    = $0B65
GL_FOG_COLOR   = $0B66

; Pixel mode, transfer

GL_PIXEL_MAP_I_TO_I = $0C70
GL_PIXEL_MAP_S_TO_S = $0C71
GL_PIXEL_MAP_I_TO_R = $0C72
GL_PIXEL_MAP_I_TO_G = $0C73
GL_PIXEL_MAP_I_TO_B = $0C74
GL_PIXEL_MAP_I_TO_A = $0C75
GL_PIXEL_MAP_R_TO_R = $0C76
GL_PIXEL_MAP_G_TO_G = $0C77
GL_PIXEL_MAP_B_TO_B = $0C78
GL_PIXEL_MAP_A_TO_A = $0C79

; Vertex arrays

GL_VERTEX_ARRAY_POINTER        = $808E
GL_NORMAL_ARRAY_POINTER        = $808F
GL_COLOR_ARRAY_POINTER	       = $8090
GL_INDEX_ARRAY_POINTER	       = $8091
GL_TEXTURE_COORD_ARRAY_POINTER = $8092
GL_EDGE_FLAG_ARRAY_POINTER     = $8093

; Stenciling

GL_STENCIL_TEST 	   = $0B90
GL_STENCIL_CLEAR_VALUE	   = $0B91
GL_STENCIL_FUNC 	   = $0B92
GL_STENCIL_VALUE_MASK	   = $0B93
GL_STENCIL_FAIL 	   = $0B94
GL_STENCIL_PASS_DEPTH_FAIL = $0B95
GL_STENCIL_PASS_DEPTH_PASS = $0B96
GL_STENCIL_REF		   = $0B97
GL_STENCIL_WRITEMASK	   = $0B98
GL_KEEP 		   = $1E00
GL_REPLACE		   = $1E01
GL_INCR 		   = $1E02
GL_DECR 		   = $1E03

; Color material

GL_COLOR_MATERIAL_FACE	    = $0B55
GL_COLOR_MATERIAL_PARAMETER = $0B56
GL_COLOR_MATERIAL	    = $0B57

; Points

GL_POINT_SMOOTH 	  = $0B10
GL_POINT_SIZE		  = $0B11
GL_POINT_SIZE_RANGE	  = $0B12
GL_POINT_SIZE_GRANULARITY = $0B13

; Lines

GL_LINE_SMOOTH		  = $0B20
GL_LINE_WIDTH		  = $0B21
GL_LINE_WIDTH_RANGE	  = $0B22
GL_LINE_WIDTH_GRANULARITY = $0B23
GL_LINE_STIPPLE 	  = $0B24
GL_LINE_STIPPLE_PATTERN   = $0B25
GL_LINE_STIPPLE_REPEAT	  = $0B26

; Polygons

GL_POLYGON_MODE    = $0B40
GL_POLYGON_SMOOTH  = $0B41
GL_POLYGON_STIPPLE = $0B42
GL_EDGE_FLAG	   = $0B43
GL_CULL_FACE	   = $0B44
GL_CULL_FACE_MODE  = $0B45
GL_FRONT_FACE	   = $0B46
GL_CW		   = $0900
GL_CCW		   = $0901
GL_POINT	   = $1B00
GL_LINE 	   = $1B01
GL_FILL 	   = $1B02

; Display lists

GL_LIST_MODE	       = $0B30
GL_LIST_BASE	       = $0B32
GL_LIST_INDEX	       = $0B33
GL_COMPILE	       = $1300
GL_COMPILE_AND_EXECUTE = $1301

; Lighting

GL_LIGHTING		     = $0B50
GL_LIGHT_MODEL_LOCAL_VIEWER  = $0B51
GL_LIGHT_MODEL_TWO_SIDE      = $0B52
GL_LIGHT_MODEL_AMBIENT	     = $0B53
GL_LIGHT_MODEL_COLOR_CONTROL = $81F8
GL_SHADE_MODEL		     = $0B54
GL_NORMALIZE		     = $0BA1
GL_AMBIENT		     = $1200
GL_DIFFUSE		     = $1201
GL_SPECULAR		     = $1202
GL_POSITION		     = $1203
GL_SPOT_DIRECTION	     = $1204
GL_SPOT_EXPONENT	     = $1205
GL_SPOT_CUTOFF		     = $1206
GL_CONSTANT_ATTENUATION      = $1207
GL_LINEAR_ATTENUATION	     = $1208
GL_QUADRATIC_ATTENUATION     = $1209
GL_EMISSION		     = $1600
GL_SHININESS		     = $1601
GL_AMBIENT_AND_DIFFUSE	     = $1602
GL_COLOR_INDEXES	     = $1603
GL_FLAT 		     = $1D00
GL_SMOOTH		     = $1D01
GL_LIGHT0		     = $4000
GL_LIGHT1		     = $4001
GL_LIGHT2		     = $4002
GL_LIGHT3		     = $4003
GL_LIGHT4		     = $4004
GL_LIGHT5		     = $4005
GL_LIGHT6		     = $4006
GL_LIGHT7		     = $4007

; Matrix modes

GL_MATRIX_MODE = $0BA0
GL_MODELVIEW   = $1700
GL_PROJECTION  = $1701
GL_TEXTURE     = $1702

; Gets

GL_CURRENT_COLOR		 = $0B00
GL_CURRENT_INDEX		 = $0B01
GL_CURRENT_NORMAL		 = $0B02
GL_CURRENT_TEXTURE_COORDS	 = $0B03
GL_CURRENT_RASTER_COLOR 	 = $0B04
GL_CURRENT_RASTER_INDEX 	 = $0B05
GL_CURRENT_RASTER_TEXTURE_COORDS = $0B06
GL_CURRENT_RASTER_POSITION	 = $0B07
GL_CURRENT_RASTER_POSITION_VALID = $0B08
GL_CURRENT_RASTER_DISTANCE	 = $0B09
GL_MAX_LIST_NESTING		 = $0B31
GL_VIEWPORT			 = $0BA2
GL_MODELVIEW_STACK_DEPTH	 = $0BA3
GL_PROJECTION_STACK_DEPTH	 = $0BA4
GL_TEXTURE_STACK_DEPTH		 = $0BA5
GL_MODELVIEW_MATRIX		 = $0BA6
GL_PROJECTION_MATRIX		 = $0BA7
GL_TEXTURE_MATRIX		 = $0BA8
GL_ATTRIB_STACK_DEPTH		 = $0BB0
GL_CLIENT_ATTRIB_STACK_DEPTH	 = $0BB1
GL_SINGLE_COLOR 		 = $81F9
GL_SEPARATE_SPECULAR_COLOR	 = $81FA

; Alpha testing

GL_ALPHA_TEST	   = $0BC0
GL_ALPHA_TEST_FUNC = $0BC1
GL_ALPHA_TEST_REF  = $0BC2

GL_LOGIC_OP_MODE		 = $0BF0
GL_INDEX_LOGIC_OP		 = $0BF1
GL_LOGIC_OP			 = $0BF1
GL_COLOR_LOGIC_OP		 = $0BF2
GL_SCISSOR_BOX			 = $0C10
GL_SCISSOR_TEST 		 = $0C11
GL_INDEX_CLEAR_VALUE		 = $0C20
GL_INDEX_WRITEMASK		 = $0C21
GL_COLOR_CLEAR_VALUE		 = $0C22
GL_COLOR_WRITEMASK		 = $0C23
GL_INDEX_MODE			 = $0C30
GL_RGBA_MODE			 = $0C31
GL_RENDER_MODE			 = $0C40
GL_PERSPECTIVE_CORRECTION_HINT	 = $0C50
GL_POINT_SMOOTH_HINT		 = $0C51
GL_LINE_SMOOTH_HINT		 = $0C52
GL_POLYGON_SMOOTH_HINT		 = $0C53
GL_FOG_HINT			 = $0C54
GL_TEXTURE_GEN_S		 = $0C60
GL_TEXTURE_GEN_T		 = $0C61
GL_TEXTURE_GEN_R		 = $0C62
GL_TEXTURE_GEN_Q		 = $0C63
GL_PIXEL_MAP_I_TO_I_SIZE	 = $0CB0
GL_PIXEL_MAP_S_TO_S_SIZE	 = $0CB1
GL_PIXEL_MAP_I_TO_R_SIZE	 = $0CB2
GL_PIXEL_MAP_I_TO_G_SIZE	 = $0CB3
GL_PIXEL_MAP_I_TO_B_SIZE	 = $0CB4
GL_PIXEL_MAP_I_TO_A_SIZE	 = $0CB5
GL_PIXEL_MAP_R_TO_R_SIZE	 = $0CB6
GL_PIXEL_MAP_G_TO_G_SIZE	 = $0CB7
GL_PIXEL_MAP_B_TO_B_SIZE	 = $0CB8
GL_PIXEL_MAP_A_TO_A_SIZE	 = $0CB9
GL_UNPACK_SWAP_BYTES		 = $0CF0
GL_UNPACK_LSB_FIRST		 = $0CF1
GL_UNPACK_ROW_LENGTH		 = $0CF2
GL_UNPACK_SKIP_ROWS		 = $0CF3
GL_UNPACK_SKIP_PIXELS		 = $0CF4
GL_UNPACK_ALIGNMENT		 = $0CF5
GL_PACK_SWAP_BYTES		 = $0D00
GL_PACK_LSB_FIRST		 = $0D01
GL_PACK_ROW_LENGTH		 = $0D02
GL_PACK_SKIP_ROWS		 = $0D03
GL_PACK_SKIP_PIXELS		 = $0D04
GL_PACK_ALIGNMENT		 = $0D05
GL_PACK_SKIP_IMAGES		 = $806B
GL_PACK_IMAGE_HEIGHT		 = $806C
GL_UNPACK_SKIP_IMAGES		 = $806D
GL_UNPACK_IMAGE_HEIGHT		 = $806E
GL_MAP_COLOR			 = $0D10
GL_MAP_STENCIL			 = $0D11
GL_INDEX_SHIFT			 = $0D12
GL_INDEX_OFFSET 		 = $0D13
GL_RED_SCALE			 = $0D14
GL_RED_BIAS			 = $0D15
GL_ZOOM_X			 = $0D16
GL_ZOOM_Y			 = $0D17
GL_GREEN_SCALE			 = $0D18
GL_GREEN_BIAS			 = $0D19
GL_BLUE_SCALE			 = $0D1A
GL_BLUE_BIAS			 = $0D1B
GL_ALPHA_SCALE			 = $0D1C
GL_ALPHA_BIAS			 = $0D1D
GL_DEPTH_SCALE			 = $0D1E
GL_DEPTH_BIAS			 = $0D1F
GL_MAX_EVAL_ORDER		 = $0D30
GL_MAX_LIGHTS			 = $0D31
GL_MAX_CLIP_PLANES		 = $0D32
GL_MAX_TEXTURE_SIZE		 = $0D33
GL_MAX_3D_TEXTURE_SIZE		 = $8073
GL_MAX_PIXEL_MAP_TABLE		 = $0D34
GL_MAX_ATTRIB_STACK_DEPTH	 = $0D35
GL_MAX_MODELVIEW_STACK_DEPTH	 = $0D36
GL_MAX_NAME_STACK_DEPTH 	 = $0D37
GL_MAX_PROJECTION_STACK_DEPTH	 = $0D38
GL_MAX_TEXTURE_STACK_DEPTH	 = $0D39
GL_MAX_VIEWPORT_DIMS		 = $0D3A
GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = $0D3B
GL_MAX_ELEMENTS_VERTICES	 = $80E8
GL_MAX_ELEMENTS_INDICES 	 = $80E9
GL_RESCALE_NORMAL		 = $803A
GL_SUBPIXEL_BITS		 = $0D50
GL_INDEX_BITS			 = $0D51
GL_RED_BITS			 = $0D52
GL_GREEN_BITS			 = $0D53
GL_BLUE_BITS			 = $0D54
GL_ALPHA_BITS			 = $0D55
GL_DEPTH_BITS			 = $0D56
GL_STENCIL_BITS 		 = $0D57
GL_ACCUM_RED_BITS		 = $0D58
GL_ACCUM_GREEN_BITS		 = $0D59
GL_ACCUM_BLUE_BITS		 = $0D5A
GL_ACCUM_ALPHA_BITS		 = $0D5B
GL_NAME_STACK_DEPTH		 = $0D70
GL_AUTO_NORMAL			 = $0D80
GL_MAP1_COLOR_4 		 = $0D90
GL_MAP1_INDEX			 = $0D91
GL_MAP1_NORMAL			 = $0D92
GL_MAP1_TEXTURE_COORD_1 	 = $0D93
GL_MAP1_TEXTURE_COORD_2 	 = $0D94
GL_MAP1_TEXTURE_COORD_3 	 = $0D95
GL_MAP1_TEXTURE_COORD_4 	 = $0D96
GL_MAP1_VERTEX_3		 = $0D97
GL_MAP1_VERTEX_4		 = $0D98
GL_MAP2_COLOR_4 		 = $0DB0
GL_MAP2_INDEX			 = $0DB1
GL_MAP2_NORMAL			 = $0DB2
GL_MAP2_TEXTURE_COORD_1 	 = $0DB3
GL_MAP2_TEXTURE_COORD_2 	 = $0DB4
GL_MAP2_TEXTURE_COORD_3 	 = $0DB5
GL_MAP2_TEXTURE_COORD_4 	 = $0DB6
GL_MAP2_VERTEX_3		 = $0DB7
GL_MAP2_VERTEX_4		 = $0DB8
GL_MAP1_GRID_DOMAIN		 = $0DD0
GL_MAP1_GRID_SEGMENTS		 = $0DD1
GL_MAP2_GRID_DOMAIN		 = $0DD2
GL_MAP2_GRID_SEGMENTS		 = $0DD3
GL_TEXTURE_1D			 = $0DE0
GL_TEXTURE_2D			 = $0DE1
GL_TEXTURE_3D			 = $806F
GL_SELECTION_BUFFER_POINTER	 = $0DF3
GL_SELECTION_BUFFER_SIZE	 = $0DF4
GL_POLYGON_OFFSET_UNITS 	 = $2A00
GL_POLYGON_OFFSET_POINT 	 = $2A01
GL_POLYGON_OFFSET_LINE		 = $2A02
GL_POLYGON_OFFSET_FILL		 = $8037
GL_POLYGON_OFFSET_FACTOR	 = $8038
GL_TEXTURE_BINDING_1D		 = $8068
GL_TEXTURE_BINDING_2D		 = $8069
GL_VERTEX_ARRAY 		 = $8074
GL_NORMAL_ARRAY 		 = $8075
GL_COLOR_ARRAY			 = $8076
GL_INDEX_ARRAY			 = $8077
GL_TEXTURE_COORD_ARRAY		 = $8078
GL_EDGE_FLAG_ARRAY		 = $8079
GL_VERTEX_ARRAY_SIZE		 = $807A
GL_VERTEX_ARRAY_TYPE		 = $807B
GL_VERTEX_ARRAY_STRIDE		 = $807C
GL_NORMAL_ARRAY_TYPE		 = $807E
GL_NORMAL_ARRAY_STRIDE		 = $807F
GL_COLOR_ARRAY_SIZE		 = $8081
GL_COLOR_ARRAY_TYPE		 = $8082
GL_COLOR_ARRAY_STRIDE		 = $8083
GL_INDEX_ARRAY_TYPE		 = $8085
GL_INDEX_ARRAY_STRIDE		 = $8086
GL_TEXTURE_COORD_ARRAY_SIZE	 = $8088
GL_TEXTURE_COORD_ARRAY_TYPE	 = $8089
GL_TEXTURE_COORD_ARRAY_STRIDE	 = $808A
GL_EDGE_FLAG_ARRAY_STRIDE	 = $808C
GL_COLOR_MATRIX 		 = $80B1
GL_COLOR_MATRIX_STACK_DEPTH	 = $80B2
GL_MAX_COLOR_MATRIX_STACK_DEPTH  = $80B3
GL_POST_COLOR_MATRIX_RED_SCALE	 = $80B4
GL_POST_COLOR_MATRIX_GREEN_SCALE = $80B5
GL_POST_COLOR_MATRIX_BLUE_SCALE  = $80B6
GL_POST_COLOR_MATRIX_ALPHA_SCALE = $80B7
GL_POST_COLOR_MATRIX_RED_BIAS	 = $80B8
GL_POST_COLOR_MATRIX_GREEN_BIAS  = $80B9
GL_POST_COLOR_MATRIX_BLUE_BIAS	 = $80BA
GL_POST_COLOR_MATRIX_ALPHA_BIAS  = $80BB

; Evaluators

GL_COEFF  = $0A00
GL_ORDER  = $0A01
GL_DOMAIN = $0A02

; Texture mapping

GL_TEXTURE_WIDTH	   = $1000
GL_TEXTURE_HEIGHT	   = $1001
GL_TEXTURE_INTERNAL_FORMAT = $1003
GL_TEXTURE_COMPONENTS	   = $1003
GL_TEXTURE_BORDER_COLOR    = $1004
GL_TEXTURE_BORDER	   = $1005
GL_TEXTURE_RED_SIZE	   = $805C
GL_TEXTURE_GREEN_SIZE	   = $805D
GL_TEXTURE_BLUE_SIZE	   = $805E
GL_TEXTURE_ALPHA_SIZE	   = $805F
GL_TEXTURE_LUMINANCE_SIZE  = $8060
GL_TEXTURE_INTENSITY_SIZE  = $8061
GL_TEXTURE_PRIORITY	   = $8066
GL_TEXTURE_RESIDENT	   = $8067
GL_BGR			   = $80E0
GL_BGRA 		   = $80E1
GL_S			   = $2000
GL_T			   = $2001
GL_R			   = $2002
GL_Q			   = $2003
GL_MODULATE		   = $2100
GL_DECAL		   = $2101
GL_TEXTURE_ENV_MODE	   = $2200
GL_TEXTURE_ENV_COLOR	   = $2201
GL_TEXTURE_ENV		   = $2300
GL_EYE_LINEAR		   = $2400
GL_OBJECT_LINEAR	   = $2401
GL_SPHERE_MAP		   = $2402
GL_TEXTURE_GEN_MODE	   = $2500
GL_OBJECT_PLANE 	   = $2501
GL_EYE_PLANE		   = $2502
GL_NEAREST		   = $2600
GL_LINEAR		   = $2601
GL_NEAREST_MIPMAP_NEAREST  = $2700
GL_LINEAR_MIPMAP_NEAREST   = $2701
GL_NEAREST_MIPMAP_LINEAR   = $2702
GL_LINEAR_MIPMAP_LINEAR    = $2703
GL_TEXTURE_MAG_FILTER	   = $2800
GL_TEXTURE_MIN_FILTER	   = $2801
GL_TEXTURE_WRAP_R	   = $8072
GL_TEXTURE_WRAP_S	   = $2802
GL_TEXTURE_WRAP_T	   = $2803
GL_CLAMP_TO_EDGE	   = $812F
GL_TEXTURE_MIN_LOD	   = $813A
GL_TEXTURE_MAX_LOD	   = $813B
GL_TEXTURE_BASE_LEVEL	   = $813C
GL_TEXTURE_MAX_LEVEL	   = $813D
GL_TEXTURE_DEPTH	   = $8071
GL_PROXY_TEXTURE_1D	   = $8063
GL_PROXY_TEXTURE_2D	   = $8064
GL_PROXY_TEXTURE_3D	   = $8070
GL_CLAMP		   = $2900
GL_REPEAT		   = $2901

; Hints

GL_DONT_CARE = $1100
GL_FASTEST   = $1101
GL_NICEST    = $1102

; Data types

GL_BYTE 	  = $1400
GL_UNSIGNED_BYTE  = $1401
GL_SHORT	  = $1402
GL_UNSIGNED_SHORT = $1403
GL_INT		  = $1404
GL_UNSIGNED_INT   = $1405
GL_FLOAT	  = $1406
GL_2_BYTES	  = $1407
GL_3_BYTES	  = $1408
GL_4_BYTES	  = $1409
GL_DOUBLE	  = $140A
GL_DOUBLE_EXT	  = $140A

; Logic operations

GL_CLEAR	 = $1500
GL_AND		 = $1501
GL_AND_REVERSE	 = $1502
GL_COPY 	 = $1503
GL_AND_INVERTED  = $1504
GL_NOOP 	 = $1505
GL_XOR		 = $1506
GL_OR		 = $1507
GL_NOR		 = $1508
GL_EQUIV	 = $1509
GL_INVERT	 = $150A
GL_OR_REVERSE	 = $150B
GL_COPY_INVERTED = $150C
GL_OR_INVERTED	 = $150D
GL_NAND 	 = $150E
GL_SET		 = $150F

; PixelCopyType

GL_COLOR   = $1800
GL_DEPTH   = $1801
GL_STENCIL = $1802

; Pixel formats

GL_COLOR_INDEX	   = $1900
GL_STENCIL_INDEX   = $1901
GL_DEPTH_COMPONENT = $1902
GL_RED		   = $1903
GL_GREEN	   = $1904
GL_BLUE 	   = $1905
GL_ALPHA	   = $1906
GL_RGB		   = $1907
GL_RGBA 	   = $1908
GL_LUMINANCE	   = $1909
GL_LUMINANCE_ALPHA = $190A

; Pixel type

GL_BITMAP = $1A00

; Rendering modes

GL_RENDER   = $1C00
GL_FEEDBACK = $1C01
GL_SELECT   = $1C02

; Implementation strings

GL_VENDOR     = $1F00
GL_RENDERER   = $1F01
GL_VERSION    = $1F02
GL_EXTENSIONS = $1F03

; Pixel formats

GL_R3_G3_B2		    = $2A10
GL_ALPHA4		    = $803B
GL_ALPHA8		    = $803C
GL_ALPHA12		    = $803D
GL_ALPHA16		    = $803E
GL_LUMINANCE4		    = $803F
GL_LUMINANCE8		    = $8040
GL_LUMINANCE12		    = $8041
GL_LUMINANCE16		    = $8042
GL_LUMINANCE4_ALPHA4	    = $8043
GL_LUMINANCE6_ALPHA2	    = $8044
GL_LUMINANCE8_ALPHA8	    = $8045
GL_LUMINANCE12_ALPHA4	    = $8046
GL_LUMINANCE12_ALPHA12	    = $8047
GL_LUMINANCE16_ALPHA16	    = $8048
GL_INTENSITY		    = $8049
GL_INTENSITY4		    = $804A
GL_INTENSITY8		    = $804B
GL_INTENSITY12		    = $804C
GL_INTENSITY16		    = $804D
GL_RGB4 		    = $804F
GL_RGB5 		    = $8050
GL_RGB8 		    = $8051
GL_RGB10		    = $8052
GL_RGB12		    = $8053
GL_RGB16		    = $8054
GL_RGBA2		    = $8055
GL_RGBA4		    = $8056
GL_RGB5_A1		    = $8057
GL_RGBA8		    = $8058
GL_RGB10_A2		    = $8059
GL_RGBA12		    = $805A
GL_RGBA16		    = $805B
UNSIGNED_BYTE_3_3_2	    = $8032
UNSIGNED_BYTE_2_3_3_REV     = $8362
UNSIGNED_SHORT_5_6_5	    = $8363
UNSIGNED_SHORT_5_6_5_REV    = $8364
UNSIGNED_SHORT_4_4_4_4	    = $8033
UNSIGNED_SHORT_4_4_4_4_REV  = $8365
UNSIGNED_SHORT_5_5_5_1	    = $8034
UNSIGNED_SHORT_1_5_5_5_REV  = $8366
UNSIGNED_INT_8_8_8_8	    = $8035
UNSIGNED_INT_8_8_8_8_REV    = $8367
UNSIGNED_INT_10_10_10_2     = $8036
UNSIGNED_INT_2_10_10_10_REV = $8368

; Interleaved arrays formats

GL_V2F		   = $2A20
GL_V3F		   = $2A21
GL_C4UB_V2F	   = $2A22
GL_C4UB_V3F	   = $2A23
GL_C3F_V3F	   = $2A24
GL_N3F_V3F	   = $2A25
GL_C4F_N3F_V3F	   = $2A26
GL_T2F_V3F	   = $2A27
GL_T4F_V4F	   = $2A28
GL_T2F_C4UB_V3F    = $2A29
GL_T2F_C3F_V3F	   = $2A2A
GL_T2F_N3F_V3F	   = $2A2B
GL_T2F_C4F_N3F_V3F = $2A2C
GL_T4F_C4F_N3F_V4F = $2A2D

; Clip planes

GL_CLIP_PLANE0 = $3000
GL_CLIP_PLANE1 = $3001
GL_CLIP_PLANE2 = $3002
GL_CLIP_PLANE3 = $3003
GL_CLIP_PLANE4 = $3004
GL_CLIP_PLANE5 = $3005

; Miscellaneous

GL_DITHER = $0BD0

; EXT_abgr

GL_ABGR_EXT = $8000

; EXT_packed_pixels

GL_UNSIGNED_BYTE_3_3_2_EXT     = $8032
GL_UNSIGNED_SHORT_4_4_4_4_EXT  = $8033
GL_UNSIGNED_SHORT_5_5_5_1_EXT  = $8034
GL_UNSIGNED_INT_8_8_8_8_EXT    = $8035
GL_UNSIGNED_INT_10_10_10_2_EXT = $8036

; EXT_vertex_array

GL_VERTEX_ARRAY_EXT		   = $8074
GL_NORMAL_ARRAY_EXT		   = $8075
GL_COLOR_ARRAY_EXT		   = $8076
GL_INDEX_ARRAY_EXT		   = $8077
GL_TEXTURE_COORD_ARRAY_EXT	   = $8078
GL_EDGE_FLAG_ARRAY_EXT		   = $8079
GL_VERTEX_ARRAY_SIZE_EXT	   = $807A
GL_VERTEX_ARRAY_TYPE_EXT	   = $807B
GL_VERTEX_ARRAY_STRIDE_EXT	   = $807C
GL_VERTEX_ARRAY_COUNT_EXT	   = $807D
GL_NORMAL_ARRAY_TYPE_EXT	   = $807E
GL_NORMAL_ARRAY_STRIDE_EXT	   = $807F
GL_NORMAL_ARRAY_COUNT_EXT	   = $8080
GL_COLOR_ARRAY_SIZE_EXT 	   = $8081
GL_COLOR_ARRAY_TYPE_EXT 	   = $8082
GL_COLOR_ARRAY_STRIDE_EXT	   = $8083
GL_COLOR_ARRAY_COUNT_EXT	   = $8084
GL_INDEX_ARRAY_TYPE_EXT 	   = $8085
GL_INDEX_ARRAY_STRIDE_EXT	   = $8086
GL_INDEX_ARRAY_COUNT_EXT	   = $8087
GL_TEXTURE_COORD_ARRAY_SIZE_EXT    = $8088
GL_TEXTURE_COORD_ARRAY_TYPE_EXT    = $8089
GL_TEXTURE_COORD_ARRAY_STRIDE_EXT  = $808A
GL_TEXTURE_COORD_ARRAY_COUNT_EXT   = $808B
GL_EDGE_FLAG_ARRAY_STRIDE_EXT	   = $808C
GL_EDGE_FLAG_ARRAY_COUNT_EXT	   = $808D
GL_VERTEX_ARRAY_POINTER_EXT	   = $808E
GL_NORMAL_ARRAY_POINTER_EXT	   = $808F
GL_COLOR_ARRAY_POINTER_EXT	   = $8090
GL_INDEX_ARRAY_POINTER_EXT	   = $8091
GL_TEXTURE_COORD_ARRAY_POINTER_EXT = $8092
GL_EDGE_FLAG_ARRAY_POINTER_EXT	   = $8093

; EXT_color_table

GL_TABLE_TOO_LARGE_EXT			   = $8031
GL_COLOR_TABLE_EXT			   = $80D0
GL_POST_CONVOLUTION_COLOR_TABLE_EXT	   = $80D1
GL_POST_COLOR_MATRIX_COLOR_TABLE_EXT	   = $80D2
GL_PROXY_COLOR_TABLE_EXT		   = $80D3
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_EXT  = $80D4
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_EXT = $80D5
GL_COLOR_TABLE_SCALE_EXT		   = $80D6
GL_COLOR_TABLE_BIAS_EXT 		   = $80D7
GL_COLOR_TABLE_FORMAT_EXT		   = $80D8
GL_COLOR_TABLE_WIDTH_EXT		   = $80D9
GL_COLOR_TABLE_RED_SIZE_EXT		   = $80DA
GL_COLOR_TABLE_GREEN_SIZE_EXT		   = $80DB
GL_COLOR_TABLE_BLUE_SIZE_EXT		   = $80DC
GL_COLOR_TABLE_ALPHA_SIZE_EXT		   = $80DD
GL_COLOR_TABLE_LUMINANCE_SIZE_EXT	   = $80DE
GL_COLOR_TABLE_INTENSITY_SIZE_EXT	   = $80DF

; EXT_bgra

GL_BGR_EXT  = $80E0
GL_BGRA_EXT = $80E1

; EXT_paletted_texture

GL_COLOR_INDEX1_EXT  = $80E2
GL_COLOR_INDEX2_EXT  = $80E3
GL_COLOR_INDEX4_EXT  = $80E4
GL_COLOR_INDEX8_EXT  = $80E5
GL_COLOR_INDEX12_EXT = $80E6
GL_COLOR_INDEX16_EXT = $80E7

; EXT_blend_color

GL_CONSTANT_COLOR_EXT		= $8001
GL_ONE_MINUS_CONSTANT_COLOR_EXT = $8002
GL_CONSTANT_ALPHA_EXT		= $8003
GL_ONE_MINUS_CONSTANT_ALPHA_EXT = $8004
GL_BLEND_COLOR_EXT		= $8005

; EXT_blend_minmax

GL_FUNC_ADD_EXT       = $8006
GL_MIN_EXT	      = $8007
GL_MAX_EXT	      = $8008
GL_BLEND_EQUATION_EXT = $8009

; EXT_blend_subtract

GL_FUNC_SUBTRACT_EXT	     = $800A
GL_FUNC_REVERSE_SUBTRACT_EXT = $800B

; EXT_convolution

GL_CONVOLUTION_1D_EXT		    = $8010
GL_CONVOLUTION_2D_EXT		    = $8011
GL_SEPARABLE_2D_EXT		    = $8012
GL_CONVOLUTION_BORDER_MODE_EXT	    = $8013
GL_CONVOLUTION_FILTER_SCALE_EXT     = $8014
GL_CONVOLUTION_FILTER_BIAS_EXT	    = $8015
GL_REDUCE_EXT			    = $8016
GL_CONVOLUTION_FORMAT_EXT	    = $8017
GL_CONVOLUTION_WIDTH_EXT	    = $8018
GL_CONVOLUTION_HEIGHT_EXT	    = $8019
GL_MAX_CONVOLUTION_WIDTH_EXT	    = $801A
GL_MAX_CONVOLUTION_HEIGHT_EXT	    = $801B
GL_POST_CONVOLUTION_RED_SCALE_EXT   = $801C
GL_POST_CONVOLUTION_GREEN_SCALE_EXT = $801D
GL_POST_CONVOLUTION_BLUE_SCALE_EXT  = $801E
GL_POST_CONVOLUTION_ALPHA_SCALE_EXT = $801F
GL_POST_CONVOLUTION_RED_BIAS_EXT    = $8020
GL_POST_CONVOLUTION_GREEN_BIAS_EXT  = $8021
GL_POST_CONVOLUTION_BLUE_BIAS_EXT   = $8022
GL_POST_CONVOLUTION_ALPHA_BIAS_EXT  = $8023

; EXT_histogram

GL_HISTOGRAM_EXT		= $8024
GL_PROXY_HISTOGRAM_EXT		= $8025
GL_HISTOGRAM_WIDTH_EXT		= $8026
GL_HISTOGRAM_FORMAT_EXT 	= $8027
GL_HISTOGRAM_RED_SIZE_EXT	= $8028
GL_HISTOGRAM_GREEN_SIZE_EXT	= $8029
GL_HISTOGRAM_BLUE_SIZE_EXT	= $802A
GL_HISTOGRAM_ALPHA_SIZE_EXT	= $802B
GL_HISTOGRAM_LUMINANCE_SIZE_EXT = $802C
GL_HISTOGRAM_SINK_EXT		= $802D
GL_MINMAX_EXT			= $802E
GL_MINMAX_FORMAT_EXT		= $802F
GL_MINMAX_SINK_EXT		= $8030

; EXT_polygon_offset

GL_POLYGON_OFFSET_EXT	     = $8037
GL_POLYGON_OFFSET_FACTOR_EXT = $8038
GL_POLYGON_OFFSET_BIAS_EXT   = $8039

; EXT_texture

GL_ALPHA4_EXT		      = $803B
GL_ALPHA8_EXT		      = $803C
GL_ALPHA12_EXT		      = $803D
GL_ALPHA16_EXT		      = $803E
GL_LUMINANCE4_EXT	      = $803F
GL_LUMINANCE8_EXT	      = $8040
GL_LUMINANCE12_EXT	      = $8041
GL_LUMINANCE16_EXT	      = $8042
GL_LUMINANCE4_ALPHA4_EXT      = $8043
GL_LUMINANCE6_ALPHA2_EXT      = $8044
GL_LUMINANCE8_ALPHA8_EXT      = $8045
GL_LUMINANCE12_ALPHA4_EXT     = $8046
GL_LUMINANCE12_ALPHA12_EXT    = $8047
GL_LUMINANCE16_ALPHA16_EXT    = $8048
GL_INTENSITY_EXT	      = $8049
GL_INTENSITY4_EXT	      = $804A
GL_INTENSITY8_EXT	      = $804B
GL_INTENSITY12_EXT	      = $804C
GL_INTENSITY16_EXT	      = $804D
GL_RGB2_EXT		      = $804E
GL_RGB4_EXT		      = $804F
GL_RGB5_EXT		      = $8050
GL_RGB8_EXT		      = $8051
GL_RGB10_EXT		      = $8052
GL_RGB12_EXT		      = $8053
GL_RGB16_EXT		      = $8054
GL_RGBA2_EXT		      = $8055
GL_RGBA4_EXT		      = $8056
GL_RGB5_A1_EXT		      = $8057
GL_RGBA8_EXT		      = $8058
GL_RGB10_A2_EXT 	      = $8059
GL_RGBA12_EXT		      = $805A
GL_RGBA16_EXT		      = $805B
GL_TEXTURE_RED_SIZE_EXT       = $805C
GL_TEXTURE_GREEN_SIZE_EXT     = $805D
GL_TEXTURE_BLUE_SIZE_EXT      = $805E
GL_TEXTURE_ALPHA_SIZE_EXT     = $805F
GL_TEXTURE_LUMINANCE_SIZE_EXT = $8060
GL_TEXTURE_INTENSITY_SIZE_EXT = $8061
GL_REPLACE_EXT		      = $8062
GL_PROXY_TEXTURE_1D_EXT       = $8063
GL_PROXY_TEXTURE_2D_EXT       = $8064
GL_TEXTURE_TOO_LARGE_EXT      = $8065

; EXT_texture_object

GL_TEXTURE_PRIORITY_EXT   = $8066
GL_TEXTURE_RESIDENT_EXT   = $8067
GL_TEXTURE_1D_BINDING_EXT = $8068
GL_TEXTURE_2D_BINDING_EXT = $8069
GL_TEXTURE_3D_BINDING_EXT = $806A

; EXT_texture3D

GL_PACK_SKIP_IMAGES_EXT    = $806B
GL_PACK_IMAGE_HEIGHT_EXT   = $806C
GL_UNPACK_SKIP_IMAGES_EXT  = $806D
GL_UNPACK_IMAGE_HEIGHT_EXT = $806E
GL_TEXTURE_3D_EXT	   = $806F
GL_PROXY_TEXTURE_3D_EXT    = $8070
GL_TEXTURE_DEPTH_EXT	   = $8071
GL_TEXTURE_WRAP_R_EXT	   = $8072
GL_MAX_3D_TEXTURE_SIZE_EXT = $8073

; SGI_color_matrix

GL_COLOR_MATRIX_SGI		     = $80B1
GL_COLOR_MATRIX_STACK_DEPTH_SGI      = $80B2
GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI  = $80B3
GL_POST_COLOR_MATRIX_RED_SCALE_SGI   = $80B4
GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI = $80B5
GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI  = $80B6
GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI = $80B7
GL_POST_COLOR_MATRIX_RED_BIAS_SGI    = $80B8
GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI  = $80B9
GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI   = $80BA
GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI  = $80BB

; SGI_texture_color_table

GL_TEXTURE_COLOR_TABLE_SGI	 = $80BC
GL_PROXY_TEXTURE_COLOR_TABLE_SGI = $80BD
GL_TEXTURE_COLOR_TABLE_BIAS_SGI  = $80BE
GL_TEXTURE_COLOR_TABLE_SCALE_SGI = $80BF

; SGI_color_table

GL_COLOR_TABLE_SGI			   = $80D0
GL_POST_CONVOLUTION_COLOR_TABLE_SGI	   = $80D1
GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI	   = $80D2
GL_PROXY_COLOR_TABLE_SGI		   = $80D3
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI  = $80D4
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI = $80D5
GL_COLOR_TABLE_SCALE_SGI		   = $80D6
GL_COLOR_TABLE_BIAS_SGI 		   = $80D7
GL_COLOR_TABLE_FORMAT_SGI		   = $80D8
GL_COLOR_TABLE_WIDTH_SGI		   = $80D9
GL_COLOR_TABLE_RED_SIZE_SGI		   = $80DA
GL_COLOR_TABLE_GREEN_SIZE_SGI		   = $80DB
GL_COLOR_TABLE_BLUE_SIZE_SGI		   = $80DC
GL_COLOR_TABLE_ALPHA_SIZE_SGI		   = $80DD
GL_COLOR_TABLE_LUMINANCE_SIZE_SGI	   = $80DE
GL_COLOR_TABLE_INTENSITY_SIZE_SGI	   = $80DF

; EXT_cmyka

GL_CMYK_EXT		= $800C
GL_CMYKA_EXT		= $800D
GL_PACK_CMYK_HINT_EXT	= $800E
GL_UNPACK_CMYK_HINT_EXT = $800F

; EXT_rescale_normal

GL_RESCALE_NORMAL_EXT = $803A

; EXT_clip_volume_hint

GL_CLIP_VOLUME_CLIPPING_HINT_EXT = $80F0

; EXT_cull_vertex

GL_CULL_VERTEX_EXT		   = $81AA
GL_CULL_VERTEX_EYE_POSITION_EXT    = $81AB
GL_CULL_VERTEX_OBJECT_POSITION_EXT = $81AC

; EXT_index_array_formats

GL_IUI_V2F_EXT	       = $81AD
GL_IUI_V3F_EXT	       = $81AE
GL_IUI_N3F_V2F_EXT     = $81AF
GL_IUI_N3F_V3F_EXT     = $81B0
GL_T2F_IUI_V2F_EXT     = $81B1
GL_T2F_IUI_V3F_EXT     = $81B2
GL_T2F_IUI_N3F_V2F_EXT = $81B3
GL_T2F_IUI_N3F_V3F_EXT = $81B4

; EXT_index_func

GL_INDEX_TEST_EXT      = $81B5
GL_INDEX_TEST_FUNC_EXT = $81B6
GL_INDEX_TEST_REF_EXT  = $81B7

; EXT_index_material

GL_INDEX_MATERIAL_EXT		= $81B8
GL_INDEX_MATERIAL_PARAMETER_EXT = $81B9
GL_INDEX_MATERIAL_FACE_EXT	= $81BA

; EXT_shared_texture_palette

GL_SHARED_TEXTURE_PALETTE_EXT = $81FB

; EXT_nurbs_tessellator

GLU_NURBS_MODE_EXT	     = 100160
GLU_NURBS_TESSELLATOR_EXT    = 100161
GLU_NURBS_RENDERER_EXT	     = 100162
GLU_NURBS_BEGIN_EXT	     = 100164
GLU_NURBS_VERTEX_EXT	     = 100165
GLU_NURBS_NORMAL_EXT	     = 100166
GLU_NURBS_COLOR_EXT	     = 100167
GLU_NURBS_TEX_COORD_EXT      = 100168
GLU_NURBS_END_EXT	     = 100169
GLU_NURBS_BEGIN_DATA_EXT     = 100170
GLU_NURBS_VERTEX_DATA_EXT    = 100171
GLU_NURBS_NORMAL_DATA_EXT    = 100172
GLU_NURBS_COLOR_DATA_EXT     = 100173
GLU_NURBS_TEX_COORD_DATA_EXT = 100174
GLU_NURBS_END_DATA_EXT	     = 100175

; EXT_object_space_tess

GLU_OBJECT_PARAMETRIC_ERROR_EXT = 100208
GLU_OBJECT_PATH_LENGTH_EXT	= 100209

; EXT_point_parameters

GL_POINT_SIZE_MIN_EXT		 = $8126
GL_POINT_SIZE_MAX_EXT		 = $8127
GL_POINT_FADE_THRESHOLD_SIZE_EXT = $8128
GL_DISTANCE_ATTENUATION_EXT	 = $8129

; EXT_compiled_vertex_array

GL_ARRAY_ELEMENT_LOCK_FIRST_EXT = $81A8
GL_ARRAY_ELEMENT_LOCK_COUNT_EXT = $81A9

; ARB_multitexture

GL_ACTIVE_TEXTURE_ARB	     = $84E0
GL_CLIENT_ACTIVE_TEXTURE_ARB = $84E1
GL_MAX_TEXTURE_UNITS_ARB     = $84E2
GL_TEXTURE0_ARB 	     = $84C0
GL_TEXTURE1_ARB 	     = $84C1
GL_TEXTURE2_ARB 	     = $84C2
GL_TEXTURE3_ARB 	     = $84C3
GL_TEXTURE4_ARB 	     = $84C4
GL_TEXTURE5_ARB 	     = $84C5
GL_TEXTURE6_ARB 	     = $84C6
GL_TEXTURE7_ARB 	     = $84C7
GL_TEXTURE8_ARB 	     = $84C8
GL_TEXTURE9_ARB 	     = $84C9
GL_TEXTURE10_ARB	     = $84CA
GL_TEXTURE11_ARB	     = $84CB
GL_TEXTURE12_ARB	     = $84CC
GL_TEXTURE13_ARB	     = $84CD
GL_TEXTURE14_ARB	     = $84CE
GL_TEXTURE15_ARB	     = $84CF
GL_TEXTURE16_ARB	     = $84D0
GL_TEXTURE17_ARB	     = $84D1
GL_TEXTURE18_ARB	     = $84D2
GL_TEXTURE19_ARB	     = $84D3
GL_TEXTURE20_ARB	     = $84D4
GL_TEXTURE21_ARB	     = $84D5
GL_TEXTURE22_ARB	     = $84D6
GL_TEXTURE23_ARB	     = $84D7
GL_TEXTURE24_ARB	     = $84D8
GL_TEXTURE25_ARB	     = $84D9
GL_TEXTURE26_ARB	     = $84DA
GL_TEXTURE27_ARB	     = $84DB
GL_TEXTURE28_ARB	     = $84DC
GL_TEXTURE29_ARB	     = $84DD
GL_TEXTURE30_ARB	     = $84DE
GL_TEXTURE31_ARB	     = $84DF

; EXT_stencil_wrap

GL_INCR_WRAP_EXT = $8507
GL_DECR_WRAP_EXT = $8508

; NV_texgen_reflection

GL_NORMAL_MAP_NV     = $8511
GL_REFLECTION_MAP_NV = $8512

; EXT_texture_env_combine

GL_COMBINE_EXT	      = $8570
GL_COMBINE_RGB_EXT    = $8571
GL_COMBINE_ALPHA_EXT  = $8572
GL_RGB_SCALE_EXT      = $8573
GL_ADD_SIGNED_EXT     = $8574
GL_INTERPOLATE_EXT    = $8575
GL_CONSTANT_EXT       = $8576
GL_PRIMARY_COLOR_EXT  = $8577
GL_PREVIOUS_EXT       = $8578
GL_SOURCE0_RGB_EXT    = $8580
GL_SOURCE1_RGB_EXT    = $8581
GL_SOURCE2_RGB_EXT    = $8582
GL_SOURCE0_ALPHA_EXT  = $8588
GL_SOURCE1_ALPHA_EXT  = $8589
GL_SOURCE2_ALPHA_EXT  = $858A
GL_OPERAND0_RGB_EXT   = $8590
GL_OPERAND1_RGB_EXT   = $8591
GL_OPERAND2_RGB_EXT   = $8592
GL_OPERAND0_ALPHA_EXT = $8598
GL_OPERAND1_ALPHA_EXT = $8599
GL_OPERAND2_ALPHA_EXT = $859A

; NV_texture_env_combine4

GL_COMBINE4_NV	     = $8503
GL_SOURCE3_RGB_NV    = $8583
GL_SOURCE3_ALPHA_NV  = $858B
GL_OPERAND3_RGB_NV   = $8593
GL_OPERAND3_ALPHA_NV = $859B

GL_BLEND_EQUATION	       = $8009
GL_TABLE_TOO_LARGE	       = $8031
GL_UNSIGNED_BYTE_3_3_2	       = $8032
GL_UNSIGNED_SHORT_4_4_4_4      = $8033
GL_UNSIGNED_SHORT_5_5_5_1      = $8034
GL_UNSIGNED_INT_8_8_8_8        = $8035
GL_UNSIGNED_INT_10_10_10_2     = $8036
GL_UNSIGNED_BYTE_2_3_3_REV     = $8362
GL_UNSIGNED_SHORT_5_6_5        = $8363
GL_UNSIGNED_SHORT_5_6_5_REV    = $8364
GL_UNSIGNED_SHORT_4_4_4_4_REV  = $8365
GL_UNSIGNED_SHORT_1_5_5_5_REV  = $8366
GL_UNSIGNED_INT_8_8_8_8_REV    = $8367
GL_UNSIGNED_INT_2_10_10_10_REV = $8368

; GL_ARB_transpose_matrix

GL_TRANSPOSE_MODELVIEW_MATRIX_ARB  = $84E3
GL_TRANSPOSE_PROJECTION_MATRIX_ARB = $84E4
GL_TRANSPOSE_TEXTURE_MATRIX_ARB    = $84E5
GL_TRANSPOSE_COLOR_MATRIX_ARB	   = $84E6

; GL_ARB_multisample

GL_MULTISAMPLE_ARB		= $809D
GL_SAMPLE_ALPHA_TO_COVERAGE_ARB = $809E
GL_SAMPLE_ALPHA_TO_ONE_ARB	= $809F
GL_SAMPLE_COVERAGE_ARB		= $80A0
GL_SAMPLE_BUFFERS_ARB		= $80A8
GL_SAMPLES_ARB			= $80A9
GL_SAMPLE_COVERAGE_VALUE_ARB	= $80AA
GL_SAMPLE_COVERAGE_INVERT_ARB	= $80AB
GL_MULTISAMPLE_BIT_ARB		= $20000000

; GL_ARB_texture_cube_map

GL_NORMAL_MAP_ARB		   = $8511
GL_REFLECTION_MAP_ARB		   = $8512
GL_TEXTURE_CUBE_MAP_ARB 	   = $8513
GL_TEXTURE_BINDING_CUBE_MAP_ARB    = $8514
GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB = $8515
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB = $8516
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB = $8517
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB = $8518
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB = $8519
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB = $851A
GL_PROXY_TEXTURE_CUBE_MAP_ARB	   = $851B
GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB   = $851C

; GL_ARB_texture_compression

GL_COMPRESSED_ALPHA_ARB 	      = $84E9
GL_COMPRESSED_LUMINANCE_ARB	      = $84EA
GL_COMPRESSED_LUMINANCE_ALPHA_ARB     = $84EB
GL_COMPRESSED_INTENSITY_ARB	      = $84EC
GL_COMPRESSED_RGB_ARB		      = $84ED
GL_COMPRESSED_RGBA_ARB		      = $84EE
GL_TEXTURE_COMPRESSION_HINT_ARB       = $84EF
GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB  = $86A0
GL_TEXTURE_COMPRESSED_ARB	      = $86A1
GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB = $86A2
GL_COMPRESSED_TEXTURE_FORMATS_ARB     = $86A3

; GL_ARB_vertex_blend

GL_MAX_VERTEX_UNITS_ARB     = $86A4
GL_ACTIVE_VERTEX_UNITS_ARB  = $86A5
GL_WEIGHT_SUM_UNITY_ARB     = $86A6
GL_VERTEX_BLEND_ARB	    = $86A7
GL_CURRENT_WEIGHT_ARB	    = $86A8
GL_WEIGHT_ARRAY_TYPE_ARB    = $86A9
GL_WEIGHT_ARRAY_STRIDE_ARB  = $86AA
GL_WEIGHT_ARRAY_SIZE_ARB    = $86AB
GL_WEIGHT_ARRAY_POINTER_ARB = $86AC
GL_WEIGHT_ARRAY_ARB	    = $86AD
GL_MODELVIEW0_ARB	    = $1700
GL_MODELVIEW1_ARB	    = $850A
GL_MODELVIEW2_ARB	    = $8722
GL_MODELVIEW3_ARB	    = $8723
GL_MODELVIEW4_ARB	    = $8724
GL_MODELVIEW5_ARB	    = $8725
GL_MODELVIEW6_ARB	    = $8726
GL_MODELVIEW7_ARB	    = $8727
GL_MODELVIEW8_ARB	    = $8728
GL_MODELVIEW9_ARB	    = $8729
GL_MODELVIEW10_ARB	    = $872A
GL_MODELVIEW11_ARB	    = $872B
GL_MODELVIEW12_ARB	    = $872C
GL_MODELVIEW13_ARB	    = $872D
GL_MODELVIEW14_ARB	    = $872E
GL_MODELVIEW15_ARB	    = $872F
GL_MODELVIEW16_ARB	    = $8730
GL_MODELVIEW17_ARB	    = $8731
GL_MODELVIEW18_ARB	    = $8732
GL_MODELVIEW19_ARB	    = $8733
GL_MODELVIEW20_ARB	    = $8734
GL_MODELVIEW21_ARB	    = $8735
GL_MODELVIEW22_ARB	    = $8736
GL_MODELVIEW23_ARB	    = $8737
GL_MODELVIEW24_ARB	    = $8738
GL_MODELVIEW25_ARB	    = $8739
GL_MODELVIEW26_ARB	    = $873A
GL_MODELVIEW27_ARB	    = $873B
GL_MODELVIEW28_ARB	    = $873C
GL_MODELVIEW29_ARB	    = $873D
GL_MODELVIEW30_ARB	    = $873E
GL_MODELVIEW31_ARB	    = $873F

; GL_SGIS_texture_filter4

GL_FILTER4_SGIS 	     = $8146
GL_TEXTURE_FILTER4_SIZE_SGIS = $8147

; GL_SGIS_pixel_texture

GL_PIXEL_TEXTURE_SGIS		    = $8353
GL_PIXEL_FRAGMENT_RGB_SOURCE_SGIS   = $8354
GL_PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS = $8355
GL_PIXEL_GROUP_COLOR_SGIS	    = $8356

; GL_SGIX_pixel_texture

GL_PIXEL_TEX_GEN_SGIX	   = $8139
GL_PIXEL_TEX_GEN_MODE_SGIX = $832B

; GL_SGIS_texture4D

GL_PACK_SKIP_VOLUMES_SGIS   = $8130
GL_PACK_IMAGE_DEPTH_SGIS    = $8131
GL_UNPACK_SKIP_VOLUMES_SGIS = $8132
GL_UNPACK_IMAGE_DEPTH_SGIS  = $8133
GL_TEXTURE_4D_SGIS	    = $8134
GL_PROXY_TEXTURE_4D_SGIS    = $8135
GL_TEXTURE_4DSIZE_SGIS	    = $8136
GL_TEXTURE_WRAP_Q_SGIS	    = $8137
GL_MAX_4D_TEXTURE_SIZE_SGIS = $8138
GL_TEXTURE_4D_BINDING_SGIS  = $814F

; GL_SGIS_detail_texture

GL_DETAIL_TEXTURE_2D_SGIS	   = $8095
GL_DETAIL_TEXTURE_2D_BINDING_SGIS  = $8096
GL_LINEAR_DETAIL_SGIS		   = $8097
GL_LINEAR_DETAIL_ALPHA_SGIS	   = $8098
GL_LINEAR_DETAIL_COLOR_SGIS	   = $8099
GL_DETAIL_TEXTURE_LEVEL_SGIS	   = $809A
GL_DETAIL_TEXTURE_MODE_SGIS	   = $809B
GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS = $809C

; GL_SGIS_sharpen_texture

GL_LINEAR_SHARPEN_SGIS		    = $80AD
GL_LINEAR_SHARPEN_ALPHA_SGIS	    = $80AE
GL_LINEAR_SHARPEN_COLOR_SGIS	    = $80AF
GL_SHARPEN_TEXTURE_FUNC_POINTS_SGIS = $80B0

; GL_SGIS_texture_lod

GL_TEXTURE_MIN_LOD_SGIS    = $813A
GL_TEXTURE_MAX_LOD_SGIS    = $813B
GL_TEXTURE_BASE_LEVEL_SGIS = $813C
GL_TEXTURE_MAX_LEVEL_SGIS  = $813D

; GL_SGIS_multisample

GL_MULTISAMPLE_SGIS	     = $809D
GL_SAMPLE_ALPHA_TO_MASK_SGIS = $809E
GL_SAMPLE_ALPHA_TO_ONE_SGIS  = $809F
GL_SAMPLE_MASK_SGIS	     = $80A0
GL_1PASS_SGIS		     = $80A1
GL_2PASS_0_SGIS 	     = $80A2
GL_2PASS_1_SGIS 	     = $80A3
GL_4PASS_0_SGIS 	     = $80A4
GL_4PASS_1_SGIS 	     = $80A5
GL_4PASS_2_SGIS 	     = $80A6
GL_4PASS_3_SGIS 	     = $80A7
GL_SAMPLE_BUFFERS_SGIS	     = $80A8
GL_SAMPLES_SGIS 	     = $80A9
GL_SAMPLE_MASK_VALUE_SGIS    = $80AA
GL_SAMPLE_MASK_INVERT_SGIS   = $80AB
GL_SAMPLE_PATTERN_SGIS	     = $80AC

; GL_SGIS_generate_mipmap

GL_GENERATE_MIPMAP_SGIS      = $8191
GL_GENERATE_MIPMAP_HINT_SGIS = $8192

; GL_SGIX_clipmap

GL_LINEAR_CLIPMAP_LINEAR_SGIX	      = $8170
GL_TEXTURE_CLIPMAP_CENTER_SGIX	      = $8171
GL_TEXTURE_CLIPMAP_FRAME_SGIX	      = $8172
GL_TEXTURE_CLIPMAP_OFFSET_SGIX	      = $8173
GL_TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX = $8174
GL_TEXTURE_CLIPMAP_LOD_OFFSET_SGIX    = $8175
GL_TEXTURE_CLIPMAP_DEPTH_SGIX	      = $8176
GL_MAX_CLIPMAP_DEPTH_SGIX	      = $8177
GL_MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX     = $8178
GL_NEAREST_CLIPMAP_NEAREST_SGIX       = $844D
GL_NEAREST_CLIPMAP_LINEAR_SGIX	      = $844E
GL_LINEAR_CLIPMAP_NEAREST_SGIX	      = $844F

; GL_SGIX_shadow

GL_TEXTURE_COMPARE_SGIX 	 = $819A
GL_TEXTURE_COMPARE_OPERATOR_SGIX = $819B
GL_TEXTURE_LEQUAL_R_SGIX	 = $819C
GL_TEXTURE_GEQUAL_R_SGIX	 = $819D

; GL_SGIS_texture_edge_clamp

GL_CLAMP_TO_EDGE_SGIS = $812F

; GL_SGIS_texture_border_clamp

GL_CLAMP_TO_BORDER_SGIS = $812D

; GL_SGIX_interlace

GL_INTERLACE_SGIX = $8094

; GL_SGIX_pixel_tiles

GL_PIXEL_TILE_BEST_ALIGNMENT_SGIX  = $813E
GL_PIXEL_TILE_CACHE_INCREMENT_SGIX = $813F
GL_PIXEL_TILE_WIDTH_SGIX	   = $8140
GL_PIXEL_TILE_HEIGHT_SGIX	   = $8141
GL_PIXEL_TILE_GRID_WIDTH_SGIX	   = $8142
GL_PIXEL_TILE_GRID_HEIGHT_SGIX	   = $8143
GL_PIXEL_TILE_GRID_DEPTH_SGIX	   = $8144
GL_PIXEL_TILE_CACHE_SIZE_SGIX	   = $8145

; GL_SGIS_texture_select

GL_DUAL_ALPHA4_SGIS	      = $8110
GL_DUAL_ALPHA8_SGIS	      = $8111
GL_DUAL_ALPHA12_SGIS	      = $8112
GL_DUAL_ALPHA16_SGIS	      = $8113
GL_DUAL_LUMINANCE4_SGIS       = $8114
GL_DUAL_LUMINANCE8_SGIS       = $8115
GL_DUAL_LUMINANCE12_SGIS      = $8116
GL_DUAL_LUMINANCE16_SGIS      = $8117
GL_DUAL_INTENSITY4_SGIS       = $8118
GL_DUAL_INTENSITY8_SGIS       = $8119
GL_DUAL_INTENSITY12_SGIS      = $811A
GL_DUAL_INTENSITY16_SGIS      = $811B
GL_DUAL_LUMINANCE_ALPHA4_SGIS = $811C
GL_DUAL_LUMINANCE_ALPHA8_SGIS = $811D
GL_QUAD_ALPHA4_SGIS	      = $811E
GL_QUAD_ALPHA8_SGIS	      = $811F
GL_QUAD_LUMINANCE4_SGIS       = $8120
GL_QUAD_LUMINANCE8_SGIS       = $8121
GL_QUAD_INTENSITY4_SGIS       = $8122
GL_QUAD_INTENSITY8_SGIS       = $8123
GL_DUAL_TEXTURE_SELECT_SGIS   = $8124
GL_QUAD_TEXTURE_SELECT_SGIS   = $8125

; GL_SGIX_sprite

GL_SPRITE_SGIX		      = $8148
GL_SPRITE_MODE_SGIX	      = $8149
GL_SPRITE_AXIS_SGIX	      = $814A
GL_SPRITE_TRANSLATION_SGIX    = $814B
GL_SPRITE_AXIAL_SGIX	      = $814C
GL_SPRITE_OBJECT_ALIGNED_SGIX = $814D
GL_SPRITE_EYE_ALIGNED_SGIX    = $814E

; GL_SGIX_texture_multi_buffer

GL_TEXTURE_MULTI_BUFFER_HINT_SGIX = $812E

; GL_SGIS_point_parameters

GL_POINT_SIZE_MIN_SGIS		  = $8126
GL_POINT_SIZE_MAX_SGIS		  = $8127
GL_POINT_FADE_THRESHOLD_SIZE_SGIS = $8128
GL_DISTANCE_ATTENUATION_SGIS	  = $8129

; GL_SGIX_instruments

GL_INSTRUMENT_BUFFER_POINTER_SGIX = $8180
GL_INSTRUMENT_MEASUREMENTS_SGIX   = $8181

; GL_SGIX_texture_scale_bias

GL_POST_TEXTURE_FILTER_BIAS_SGIX	= $8179
GL_POST_TEXTURE_FILTER_SCALE_SGIX	= $817A
GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX	= $817B
GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX = $817C

; GL_SGIX_framezoom

GL_FRAMEZOOM_SGIX	     = $818B
GL_FRAMEZOOM_FACTOR_SGIX     = $818C
GL_MAX_FRAMEZOOM_FACTOR_SGIX = $818D

; GL_FfdMaskSGIX

GL_TEXTURE_DEFORMATION_BIT_SGIX  = $00000001
GL_GEOMETRY_DEFORMATION_BIT_SGIX = $00000002

; GL_SGIX_polynomial_ffd

GL_GEOMETRY_DEFORMATION_SGIX  = $8194
GL_TEXTURE_DEFORMATION_SGIX   = $8195
GL_DEFORMATIONS_MASK_SGIX     = $8196
GL_MAX_DEFORMATION_ORDER_SGIX = $8197

; GL_SGIX_reference_plane

GL_REFERENCE_PLANE_SGIX 	 = $817D
GL_REFERENCE_PLANE_EQUATION_SGIX = $817E

; GL_SGIX_depth_texture

GL_DEPTH_COMPONENT16_SGIX = $81A5
GL_DEPTH_COMPONENT24_SGIX = $81A6
GL_DEPTH_COMPONENT32_SGIX = $81A7

; GL_SGIS_fog_function

GL_FOG_FUNC_SGIS	    = $812A
GL_FOG_FUNC_POINTS_SGIS     = $812B
GL_MAX_FOG_FUNC_POINTS_SGIS = $812C

; GL_SGIX_fog_offset

GL_FOG_OFFSET_SGIX	 = $8198
GL_FOG_OFFSET_VALUE_SGIX = $8199

; GL_HP_image_transform

GL_IMAGE_SCALE_X_HP			     = $8155
GL_IMAGE_SCALE_Y_HP			     = $8156
GL_IMAGE_TRANSLATE_X_HP 		     = $8157
GL_IMAGE_TRANSLATE_Y_HP 		     = $8158
GL_IMAGE_ROTATE_ANGLE_HP		     = $8159
GL_IMAGE_ROTATE_ORIGIN_X_HP		     = $815A
GL_IMAGE_ROTATE_ORIGIN_Y_HP		     = $815B
GL_IMAGE_MAG_FILTER_HP			     = $815C
GL_IMAGE_MIN_FILTER_HP			     = $815D
GL_IMAGE_CUBIC_WEIGHT_HP		     = $815E
GL_CUBIC_HP				     = $815F
GL_AVERAGE_HP				     = $8160
GL_IMAGE_TRANSFORM_2D_HP		     = $8161
GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP	     = $8162
GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP = $8163

; GL_HP_convolution_border_modes

GL_IGNORE_BORDER_HP	       = $8150
GL_CONSTANT_BORDER_HP	       = $8151
GL_REPLICATE_BORDER_HP	       = $8153
GL_CONVOLUTION_BORDER_COLOR_HP = $8154

; GL_SGIX_texture_add_env

GL_TEXTURE_ENV_BIAS_SGIX = $80BE

; GL_PGI_vertex_hints

GL_VERTEX_DATA_HINT_PGI 	   = $1A22A
GL_VERTEX_CONSISTENT_HINT_PGI	   = $1A22B
GL_MATERIAL_SIDE_HINT_PGI	   = $1A22C
GL_MAX_VERTEX_HINT_PGI		   = $1A22D
GL_COLOR3_BIT_PGI		   = $00010000
GL_COLOR4_BIT_PGI		   = $00020000
GL_EDGEFLAG_BIT_PGI		   = $00040000
GL_INDEX_BIT_PGI		   = $00080000
GL_MAT_AMBIENT_BIT_PGI		   = $00100000
GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI = $00200000
GL_MAT_DIFFUSE_BIT_PGI		   = $00400000
GL_MAT_EMISSION_BIT_PGI 	   = $00800000
GL_MAT_COLOR_INDEXES_BIT_PGI	   = $01000000
GL_MAT_SHININESS_BIT_PGI	   = $02000000
GL_MAT_SPECULAR_BIT_PGI 	   = $04000000
GL_NORMAL_BIT_PGI		   = $08000000
GL_TEXCOORD1_BIT_PGI		   = $10000000
GL_TEXCOORD2_BIT_PGI		   = $20000000
GL_TEXCOORD3_BIT_PGI		   = $40000000
GL_TEXCOORD4_BIT_PGI		   = $80000000
GL_VERTEX23_BIT_PGI		   = $00000004
GL_VERTEX4_BIT_PGI		   = $00000008

; GL_PGI_misc_hints

GL_PREFER_DOUBLEBUFFER_HINT_PGI   = $1A1F8
GL_CONSERVE_MEMORY_HINT_PGI	  = $1A1FD
GL_RECLAIM_MEMORY_HINT_PGI	  = $1A1FE
GL_NATIVE_GRAPHICS_HANDLE_PGI	  = $1A202
GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI = $1A203
GL_NATIVE_GRAPHICS_END_HINT_PGI   = $1A204
GL_ALWAYS_FAST_HINT_PGI 	  = $1A20C
GL_ALWAYS_SOFT_HINT_PGI 	  = $1A20D
GL_ALLOW_DRAW_OBJ_HINT_PGI	  = $1A20E
GL_ALLOW_DRAW_WIN_HINT_PGI	  = $1A20F
GL_ALLOW_DRAW_FRG_HINT_PGI	  = $1A210
GL_ALLOW_DRAW_MEM_HINT_PGI	  = $1A211
GL_STRICT_DEPTHFUNC_HINT_PGI	  = $1A216
GL_STRICT_LIGHTING_HINT_PGI	  = $1A217
GL_STRICT_SCISSOR_HINT_PGI	  = $1A218
GL_FULL_STIPPLE_HINT_PGI	  = $1A219
GL_CLIP_NEAR_HINT_PGI		  = $1A220
GL_CLIP_FAR_HINT_PGI		  = $1A221
GL_WIDE_LINE_HINT_PGI		  = $1A222
GL_BACK_NORMALS_HINT_PGI	  = $1A223

; GL_EXT_paletted_texture

GL_TEXTURE_INDEX_SIZE_EXT = $80ED

; GL_SGIX_list_priority

GL_LIST_PRIORITY_SGIX = $8182

; GL_SGIX_ir_instrument1

GL_IR_INSTRUMENT1_SGIX = $817F

; GL_SGIX_calligraphic_fragment

GL_CALLIGRAPHIC_FRAGMENT_SGIX = $8183

; GL_SGIX_texture_lod_bias

GL_TEXTURE_LOD_BIAS_S_SGIX = $818E
GL_TEXTURE_LOD_BIAS_T_SGIX = $818F
GL_TEXTURE_LOD_BIAS_R_SGIX = $8190

; GL_SGIX_shadow_ambient

GL_SHADOW_AMBIENT_SGIX = $80BF

; GL_SGIX_ycrcb

GL_YCRCB_422_SGIX = $81BB
GL_YCRCB_444_SGIX = $81BC

; GL_SGIX_fragment_lighting

GL_FRAGMENT_LIGHTING_SGIX			  = $8400
GL_FRAGMENT_COLOR_MATERIAL_SGIX 		  = $8401
GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX		  = $8402
GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX	  = $8403
GL_MAX_FRAGMENT_LIGHTS_SGIX			  = $8404
GL_MAX_ACTIVE_LIGHTS_SGIX			  = $8405
GL_CURRENT_RASTER_NORMAL_SGIX			  = $8406
GL_LIGHT_ENV_MODE_SGIX				  = $8407
GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX	  = $8408
GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX		  = $8409
GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX		  = $840A
GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX = $840B
GL_FRAGMENT_LIGHT0_SGIX 			  = $840C
GL_FRAGMENT_LIGHT1_SGIX 			  = $840D
GL_FRAGMENT_LIGHT2_SGIX 			  = $840E
GL_FRAGMENT_LIGHT3_SGIX 			  = $840F
GL_FRAGMENT_LIGHT4_SGIX 			  = $8410
GL_FRAGMENT_LIGHT5_SGIX 			  = $8411
GL_FRAGMENT_LIGHT6_SGIX 			  = $8412
GL_FRAGMENT_LIGHT7_SGIX 			  = $8413

; GL_IBM_rasterpos_clip

GL_RASTER_POSITION_UNCLIPPED_IBM = $19262

; GL_HP_texture_lighting

GL_TEXTURE_LIGHTING_MODE_HP = $8167
GL_TEXTURE_POST_SPECULAR_HP = $8168
GL_TEXTURE_PRE_SPECULAR_HP  = $8169

; GL_EXT_draw_range_elements

GL_MAX_ELEMENTS_VERTICES_EXT = $80E8
GL_MAX_ELEMENTS_INDICES_EXT  = $80E9

; GL_WIN_phong_shading

GL_PHONG_WIN	  = $80EA
GL_PHONG_HINT_WIN = $80EB

; GL_WIN_specular_fog

GL_FOG_SPECULAR_TEXTURE_WIN = $80EC

; GL_EXT_light_texture

GL_FRAGMENT_MATERIAL_EXT	  = $8349
GL_FRAGMENT_NORMAL_EXT		  = $834A
GL_FRAGMENT_COLOR_EXT		  = $834C
GL_ATTENUATION_EXT		  = $834D
GL_SHADOW_ATTENUATION_EXT	  = $834E
GL_TEXTURE_APPLICATION_MODE_EXT   = $834F
GL_TEXTURE_LIGHT_EXT		  = $8350
GL_TEXTURE_MATERIAL_FACE_EXT	  = $8351
GL_TEXTURE_MATERIAL_PARAMETER_EXT = $8352

; GL_SGIX_blend_alpha_minmax

GL_ALPHA_MIN_SGIX = $8320
GL_ALPHA_MAX_SGIX = $8321

; GL_SGIX_async

GL_ASYNC_MARKER_SGIX  = $8329

; GL_SGIX_async_pixel

GL_ASYNC_TEX_IMAGE_SGIX       = $835C
GL_ASYNC_DRAW_PIXELS_SGIX     = $835D
GL_ASYNC_READ_PIXELS_SGIX     = $835E
GL_MAX_ASYNC_TEX_IMAGE_SGIX   = $835F
GL_MAX_ASYNC_DRAW_PIXELS_SGIX = $8360
GL_MAX_ASYNC_READ_PIXELS_SGIX = $8361

; GL_SGIX_async_histogram

GL_ASYNC_HISTOGRAM_SGIX     = $832C
GL_MAX_ASYNC_HISTOGRAM_SGIX = $832D

; GL_INTEL_parallel_arrays

GL_PARALLEL_ARRAYS_INTEL		       = $83F4
GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL        = $83F5
GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL        = $83F6
GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL	       = $83F7
GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL = $83F8

; GL_HP_occlusion_test

GL_OCCLUSION_TEST_HP	    = $8165
GL_OCCLUSION_TEST_RESULT_HP = $8166

; GL_EXT_pixel_transform

GL_PIXEL_TRANSFORM_2D_EXT		  = $8330
GL_PIXEL_MAG_FILTER_EXT 		  = $8331
GL_PIXEL_MIN_FILTER_EXT 		  = $8332
GL_PIXEL_CUBIC_WEIGHT_EXT		  = $8333
GL_CUBIC_EXT				  = $8334
GL_AVERAGE_EXT				  = $8335
GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT	  = $8336
GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = $8337
GL_PIXEL_TRANSFORM_2D_MATRIX_EXT	  = $8338

; GL_EXT_separate_specular_color

GL_LIGHT_MODEL_COLOR_CONTROL_EXT = $81F8
GL_SINGLE_COLOR_EXT		 = $81F9
GL_SEPARATE_SPECULAR_COLOR_EXT	 = $81FA

; GL_EXT_secondary_color

GL_COLOR_SUM_EXT		     = $8458
GL_CURRENT_SECONDARY_COLOR_EXT	     = $8459
GL_SECONDARY_COLOR_ARRAY_SIZE_EXT    = $845A
GL_SECONDARY_COLOR_ARRAY_TYPE_EXT    = $845B
GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT  = $845C
GL_SECONDARY_COLOR_ARRAY_POINTER_EXT = $845D
GL_SECONDARY_COLOR_ARRAY_EXT	     = $845E

; GL_EXT_texture_perturb_normal

GL_PERTURB_EXT	      = $85AE
GL_TEXTURE_NORMAL_EXT = $85AF

; GL_EXT_fog_coord

GL_FOG_COORDINATE_SOURCE_EXT	    = $8450
GL_FOG_COORDINATE_EXT		    = $8451
GL_FRAGMENT_DEPTH_EXT		    = $8452
GL_CURRENT_FOG_COORDINATE_EXT	    = $8453
GL_FOG_COORDINATE_ARRAY_TYPE_EXT    = $8454
GL_FOG_COORDINATE_ARRAY_STRIDE_EXT  = $8455
GL_FOG_COORDINATE_ARRAY_POINTER_EXT = $8456
GL_FOG_COORDINATE_ARRAY_EXT	    = $8457

; GL_REND_screen_coordinates

GL_SCREEN_COORDINATES_REND = $8490
GL_INVERTED_SCREEN_W_REND  = $8491

; GL_EXT_coordinate_frame

GL_TANGENT_ARRAY_EXT	      = $8439
GL_BINORMAL_ARRAY_EXT	      = $843A
GL_CURRENT_TANGENT_EXT	      = $843B
GL_CURRENT_BINORMAL_EXT       = $843C
GL_TANGENT_ARRAY_TYPE_EXT     = $843E
GL_TANGENT_ARRAY_STRIDE_EXT   = $843F
GL_BINORMAL_ARRAY_TYPE_EXT    = $8440
GL_BINORMAL_ARRAY_STRIDE_EXT  = $8441
GL_TANGENT_ARRAY_POINTER_EXT  = $8442
GL_BINORMAL_ARRAY_POINTER_EXT = $8443
GL_MAP1_TANGENT_EXT	      = $8444
GL_MAP2_TANGENT_EXT	      = $8445
GL_MAP1_BINORMAL_EXT	      = $8446
GL_MAP2_BINORMAL_EXT	      = $8447

; GL_EXT_texture_env_combine

GL_SOURCE3_RGB_EXT    = $8583
GL_SOURCE4_RGB_EXT    = $8584
GL_SOURCE5_RGB_EXT    = $8585
GL_SOURCE6_RGB_EXT    = $8586
GL_SOURCE7_RGB_EXT    = $8587
GL_SOURCE3_ALPHA_EXT  = $858B
GL_SOURCE4_ALPHA_EXT  = $858C
GL_SOURCE5_ALPHA_EXT  = $858D
GL_SOURCE6_ALPHA_EXT  = $858E
GL_SOURCE7_ALPHA_EXT  = $858F
GL_OPERAND3_RGB_EXT   = $8593
GL_OPERAND4_RGB_EXT   = $8594
GL_OPERAND5_RGB_EXT   = $8595
GL_OPERAND6_RGB_EXT   = $8596
GL_OPERAND7_RGB_EXT   = $8597
GL_OPERAND3_ALPHA_EXT = $859B
GL_OPERAND4_ALPHA_EXT = $859C
GL_OPERAND5_ALPHA_EXT = $859D
GL_OPERAND6_ALPHA_EXT = $859E
GL_OPERAND7_ALPHA_EXT = $859F

; GL_APPLE_specular_vector

GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE = $85B0

; GL_APPLE_transform_hint

GL_TRANSFORM_HINT_APPLE = $85B1

; GL_SGIX_fog_scale

GL_FOG_SCALE_SGIX	= $81FC
GL_FOG_SCALE_VALUE_SGIX = $81FD

; GL_SUNX_constant_data

GL_UNPACK_CONSTANT_DATA_SUNX  = $81D5
GL_TEXTURE_CONSTANT_DATA_SUNX = $81D6

; GL_SUN_global_alpha

GL_GLOBAL_ALPHA_SUN	   = $81D9
GL_GLOBAL_ALPHA_FACTOR_SUN = $81DA

; GL_SUN_triangle_list

GL_RESTART_SUN			      = $01
GL_REPLACE_MIDDLE_SUN		      = $02
GL_REPLACE_OLDEST_SUN		      = $03
GL_TRIANGLE_LIST_SUN		      = $81D7
GL_REPLACEMENT_CODE_SUN 	      = $81D8
GL_REPLACEMENT_CODE_ARRAY_SUN	      = $85C0
GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN    = $85C1
GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN  = $85C2
GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN = $85C3
GL_R1UI_V3F_SUN 		      = $85C4
GL_R1UI_C4UB_V3F_SUN		      = $85C5
GL_R1UI_C3F_V3F_SUN		      = $85C6
GL_R1UI_N3F_V3F_SUN		      = $85C7
GL_R1UI_C4F_N3F_V3F_SUN 	      = $85C8
GL_R1UI_T2F_V3F_SUN		      = $85C9
GL_R1UI_T2F_N3F_V3F_SUN 	      = $85CA
GL_R1UI_T2F_C4F_N3F_V3F_SUN	      = $85CB

; GL_EXT_blend_func_separate

GL_BLEND_DST_RGB_EXT   = $80C8
GL_BLEND_SRC_RGB_EXT   = $80C9
GL_BLEND_DST_ALPHA_EXT = $80CA
GL_BLEND_SRC_ALPHA_EXT = $80CB

; GL_INGR_color_clamp

GL_RED_MIN_CLAMP_INGR	= $8560
GL_GREEN_MIN_CLAMP_INGR = $8561
GL_BLUE_MIN_CLAMP_INGR	= $8562
GL_ALPHA_MIN_CLAMP_INGR = $8563
GL_RED_MAX_CLAMP_INGR	= $8564
GL_GREEN_MAX_CLAMP_INGR = $8565
GL_BLUE_MAX_CLAMP_INGR	= $8566
GL_ALPHA_MAX_CLAMP_INGR = $8567

; GL_INGR_interlace_read

GL_INTERLACE_READ_INGR = $8568

; GL_EXT_422_pixels

GL_422_EXT	       = $80CC
GL_422_REV_EXT	       = $80CD
GL_422_AVERAGE_EXT     = $80CE
GL_422_REV_AVERAGE_EXT = $80CF

; GL_EXT_texture_cube_map

GL_NORMAL_MAP_EXT		   = $8511
GL_REFLECTION_MAP_EXT		   = $8512
GL_TEXTURE_CUBE_MAP_EXT 	   = $8513
GL_TEXTURE_BINDING_CUBE_MAP_EXT    = $8514
GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT = $8515
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT = $8516
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT = $8517
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT = $8518
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT = $8519
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT = $851A
GL_PROXY_TEXTURE_CUBE_MAP_EXT	   = $851B
GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT   = $851C

; GL_SUN_convolution_border_modes

GL_WRAP_BORDER_SUN = $81D4

; GL_EXT_texture_lod_bias

GL_MAX_TEXTURE_LOD_BIAS_EXT   = $84FD
GL_TEXTURE_FILTER_CONTROL_EXT = $8500
GL_TEXTURE_LOD_BIAS_EXT       = $8501

; GL_EXT_texture_filter_anisotropic

GL_TEXTURE_MAX_ANISOTROPY_EXT	  = $84FE
GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = $84FF

; GL_EXT_vertex_weighting

GL_MODELVIEW0_STACK_DEPTH_EXT	   = GL_MODELVIEW_STACK_DEPTH
GL_MODELVIEW1_STACK_DEPTH_EXT	   = $8502
GL_MODELVIEW0_MATRIX_EXT	   = GL_MODELVIEW_MATRIX
GL_MODELVIEW_MATRIX1_EXT	   = $8506
GL_VERTEX_WEIGHTING_EXT 	   = $8509
GL_MODELVIEW0_EXT		   = GL_MODELVIEW
GL_MODELVIEW1_EXT		   = $850A
GL_CURRENT_VERTEX_WEIGHT_EXT	   = $850B
GL_VERTEX_WEIGHT_ARRAY_EXT	   = $850C
GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT    = $850D
GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT    = $850E
GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT  = $850F
GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT = $8510

; GL_NV_light_max_exponent

GL_MAX_SHININESS_NV	= $8504
GL_MAX_SPOT_EXPONENT_NV = $8505

; GL_NV_vertex_array_range

GL_VERTEX_ARRAY_RANGE_NV	     = $851D
GL_VERTEX_ARRAY_RANGE_LENGTH_NV      = $851E
GL_VERTEX_ARRAY_RANGE_VALID_NV	     = $851F
GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV = $8520
GL_VERTEX_ARRAY_RANGE_POINTER_NV     = $8521

; GL_NV_register_combiners

GL_REGISTER_COMBINERS_NV	  = $8522
GL_VARIABLE_A_NV		  = $8523
GL_VARIABLE_B_NV		  = $8524
GL_VARIABLE_C_NV		  = $8525
GL_VARIABLE_D_NV		  = $8526
GL_VARIABLE_E_NV		  = $8527
GL_VARIABLE_F_NV		  = $8528
GL_VARIABLE_G_NV		  = $8529
GL_CONSTANT_COLOR0_NV		  = $852A
GL_CONSTANT_COLOR1_NV		  = $852B
GL_PRIMARY_COLOR_NV		  = $852C
GL_SECONDARY_COLOR_NV		  = $852D
GL_SPARE0_NV			  = $852E
GL_SPARE1_NV			  = $852F
GL_DISCARD_NV			  = $8530
GL_E_TIMES_F_NV 		  = $8531
GL_SPARE0_PLUS_SECONDARY_COLOR_NV = $8532
GL_UNSIGNED_IDENTITY_NV 	  = $8536
GL_UNSIGNED_INVERT_NV		  = $8537
GL_EXPAND_NORMAL_NV		  = $8538
GL_EXPAND_NEGATE_NV		  = $8539
GL_HALF_BIAS_NORMAL_NV		  = $853A
GL_HALF_BIAS_NEGATE_NV		  = $853B
GL_SIGNED_IDENTITY_NV		  = $853C
GL_SIGNED_NEGATE_NV		  = $853D
GL_SCALE_BY_TWO_NV		  = $853E
GL_SCALE_BY_FOUR_NV		  = $853F
GL_SCALE_BY_ONE_HALF_NV 	  = $8540
GL_BIAS_BY_NEGATIVE_ONE_HALF_NV   = $8541
GL_COMBINER_INPUT_NV		  = $8542
GL_COMBINER_MAPPING_NV		  = $8543
GL_COMBINER_COMPONENT_USAGE_NV	  = $8544
GL_COMBINER_AB_DOT_PRODUCT_NV	  = $8545
GL_COMBINER_CD_DOT_PRODUCT_NV	  = $8546
GL_COMBINER_MUX_SUM_NV		  = $8547
GL_COMBINER_SCALE_NV		  = $8548
GL_COMBINER_BIAS_NV		  = $8549
GL_COMBINER_AB_OUTPUT_NV	  = $854A
GL_COMBINER_CD_OUTPUT_NV	  = $854B
GL_COMBINER_SUM_OUTPUT_NV	  = $854C
GL_MAX_GENERAL_COMBINERS_NV	  = $854D
GL_NUM_GENERAL_COMBINERS_NV	  = $854E
GL_COLOR_SUM_CLAMP_NV		  = $854F
GL_COMBINER0_NV 		  = $8550
GL_COMBINER1_NV 		  = $8551
GL_COMBINER2_NV 		  = $8552
GL_COMBINER3_NV 		  = $8553
GL_COMBINER4_NV 		  = $8554
GL_COMBINER5_NV 		  = $8555
GL_COMBINER6_NV 		  = $8556
GL_COMBINER7_NV 		  = $8557

; GL_NV_fog_distance

GL_FOG_DISTANCE_MODE_NV  = $855A
GL_EYE_RADIAL_NV	 = $855B
GL_EYE_PLANE_ABSOLUTE_NV = $855C

; GL_NV_texgen_emboss

GL_EMBOSS_LIGHT_NV    = $855D
GL_EMBOSS_CONSTANT_NV = $855E
GL_EMBOSS_MAP_NV      = $855F

; GL_EXT_texture_compression_s3tc

GL_COMPRESSED_RGB_S3TC_DXT1_EXT  = $83F0
GL_COMPRESSED_RGBA_S3TC_DXT1_EXT = $83F1
GL_COMPRESSED_RGBA_S3TC_DXT3_EXT = $83F2
GL_COMPRESSED_RGBA_S3TC_DXT5_EXT = $83F3

; GL_IBM_cull_vertex

GL_CULL_VERTEX_IBM = 103050

; GL_IBM_vertex_array_lists

GL_VERTEX_ARRAY_LIST_IBM		 = 103070
GL_NORMAL_ARRAY_LIST_IBM		 = 103071
GL_COLOR_ARRAY_LIST_IBM 		 = 103072
GL_INDEX_ARRAY_LIST_IBM 		 = 103073
GL_TEXTURE_COORD_ARRAY_LIST_IBM 	 = 103074
GL_EDGE_FLAG_ARRAY_LIST_IBM		 = 103075
GL_FOG_COORDINATE_ARRAY_LIST_IBM	 = 103076
GL_SECONDARY_COLOR_ARRAY_LIST_IBM	 = 103077
GL_VERTEX_ARRAY_LIST_STRIDE_IBM 	 = 103080
GL_NORMAL_ARRAY_LIST_STRIDE_IBM 	 = 103081
GL_COLOR_ARRAY_LIST_STRIDE_IBM		 = 103082
GL_INDEX_ARRAY_LIST_STRIDE_IBM		 = 103083
GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM	 = 103084
GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM	 = 103085
GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM  = 103086
GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM = 103087

; GL_SGIX_subsample

GL_PACK_SUBSAMPLE_RATE_SGIX   = $85A0
GL_UNPACK_SUBSAMPLE_RATE_SGIX = $85A1
GL_PIXEL_SUBSAMPLE_4444_SGIX  = $85A2
GL_PIXEL_SUBSAMPLE_2424_SGIX  = $85A3
GL_PIXEL_SUBSAMPLE_4242_SGIX  = $85A4

; GL_SGIX_ycrcba

GL_YCRCB_SGIX  = $8318
GL_YCRCBA_SGIX = $8319

; GL_SGI_depth_pass_instrument

GL_DEPTH_PASS_INSTRUMENT_SGIX	       = $8310
GL_DEPTH_PASS_INSTRUMENT_COUNTERS_SGIX = $8311
GL_DEPTH_PASS_INSTRUMENT_MAX_SGIX      = $8312

; GL_3DFX_texture_compression_FXT1

GL_COMPRESSED_RGB_FXT1_3DFX  = $86B0
GL_COMPRESSED_RGBA_FXT1_3DFX = $86B1

; GL_3DFX_multisample

GL_MULTISAMPLE_3DFX	= $86B2
GL_SAMPLE_BUFFERS_3DFX	= $86B3
GL_SAMPLES_3DFX 	= $86B4
GL_MULTISAMPLE_BIT_3DFX = $20000000

; GL_EXT_multisample

GL_MULTISAMPLE_EXT	    = $809D
GL_SAMPLE_ALPHA_TO_MASK_EXT = $809E
GL_SAMPLE_ALPHA_TO_ONE_EXT  = $809F
GL_SAMPLE_MASK_EXT	    = $80A0
GL_1PASS_EXT		    = $80A1
GL_2PASS_0_EXT		    = $80A2
GL_2PASS_1_EXT		    = $80A3
GL_4PASS_0_EXT		    = $80A4
GL_4PASS_1_EXT		    = $80A5
GL_4PASS_2_EXT		    = $80A6
GL_4PASS_3_EXT		    = $80A7
GL_SAMPLE_BUFFERS_EXT	    = $80A8
GL_SAMPLES_EXT		    = $80A9
GL_SAMPLE_MASK_VALUE_EXT    = $80AA
GL_SAMPLE_MASK_INVERT_EXT   = $80AB
GL_SAMPLE_PATTERN_EXT	    = $80AC

; GL_SGIX_vertex_preclip

GL_VERTEX_PRECLIP_SGIX	    = $83EE
GL_VERTEX_PRECLIP_HINT_SGIX = $83EF

; GL_SGIX_convolution_accuracy

GL_CONVOLUTION_HINT_SGIX = $8316

; GL_SGIX_resample

GL_PACK_RESAMPLE_SGIX	   = $842C
GL_UNPACK_RESAMPLE_SGIX    = $842D
GL_RESAMPLE_REPLICATE_SGIX = $842E
GL_RESAMPLE_ZERO_FILL_SGIX = $842F
GL_RESAMPLE_DECIMATE_SGIX  = $8430

; GL_SGIS_point_line_texgen

GL_EYE_DISTANCE_TO_POINT_SGIS	 = $81F0
GL_OBJECT_DISTANCE_TO_POINT_SGIS = $81F1
GL_EYE_DISTANCE_TO_LINE_SGIS	 = $81F2
GL_OBJECT_DISTANCE_TO_LINE_SGIS  = $81F3
GL_EYE_POINT_SGIS		 = $81F4
GL_OBJECT_POINT_SGIS		 = $81F5
GL_EYE_LINE_SGIS		 = $81F6
GL_OBJECT_LINE_SGIS		 = $81F7

; GL_SGIS_texture_color_mask

GL_TEXTURE_COLOR_WRITEMASK_SGIS = $81EF

; GL_NV_vertex_program

GL_VERTEX_PROGRAM_NV		   = $8620
GL_VERTEX_STATE_PROGRAM_NV	   = $8621
GL_ATTRIB_ARRAY_SIZE_NV 	   = $8623
GL_ATTRIB_ARRAY_STRIDE_NV	   = $8624
GL_ATTRIB_ARRAY_TYPE_NV 	   = $8625
GL_CURRENT_ATTRIB_NV		   = $8626
GL_PROGRAM_LENGTH_NV		   = $8627
GL_PROGRAM_STRING_NV		   = $8628
GL_MODELVIEW_PROJECTION_NV	   = $8629
GL_IDENTITY_NV			   = $862A
GL_INVERSE_NV			   = $862B
GL_TRANSPOSE_NV 		   = $862C
GL_INVERSE_TRANSPOSE_NV 	   = $862D
GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV = $862E
GL_MAX_TRACK_MATRICES_NV	   = $862F
GL_MATRIX0_NV			   = $8630
GL_MATRIX1_NV			   = $8631
GL_MATRIX2_NV			   = $8632
GL_MATRIX3_NV			   = $8633
GL_MATRIX4_NV			   = $8634
GL_MATRIX5_NV			   = $8635
GL_MATRIX6_NV			   = $8636
GL_MATRIX7_NV			   = $8637
GL_CURRENT_MATRIX_STACK_DEPTH_NV   = $8640
GL_CURRENT_MATRIX_NV		   = $8641
GL_VERTEX_PROGRAM_POINT_SIZE_NV    = $8642
GL_VERTEX_PROGRAM_TWO_SIDE_NV	   = $8643
GL_PROGRAM_PARAMETER_NV 	   = $8644
GL_ATTRIB_ARRAY_POINTER_NV	   = $8645
GL_PROGRAM_TARGET_NV		   = $8646
GL_PROGRAM_RESIDENT_NV		   = $8647
GL_TRACK_MATRIX_NV		   = $8648
GL_TRACK_MATRIX_TRANSFORM_NV	   = $8649
GL_VERTEX_PROGRAM_BINDING_NV	   = $864A
GL_PROGRAM_ERROR_POSITION_NV	   = $864B
GL_VERTEX_ATTRIB_ARRAY0_NV	   = $8650
GL_VERTEX_ATTRIB_ARRAY1_NV	   = $8651
GL_VERTEX_ATTRIB_ARRAY2_NV	   = $8652
GL_VERTEX_ATTRIB_ARRAY3_NV	   = $8653
GL_VERTEX_ATTRIB_ARRAY4_NV	   = $8654
GL_VERTEX_ATTRIB_ARRAY5_NV	   = $8655
GL_VERTEX_ATTRIB_ARRAY6_NV	   = $8656
GL_VERTEX_ATTRIB_ARRAY7_NV	   = $8657
GL_VERTEX_ATTRIB_ARRAY8_NV	   = $8658
GL_VERTEX_ATTRIB_ARRAY9_NV	   = $8659
GL_VERTEX_ATTRIB_ARRAY10_NV	   = $865A
GL_VERTEX_ATTRIB_ARRAY11_NV	   = $865B
GL_VERTEX_ATTRIB_ARRAY12_NV	   = $865C
GL_VERTEX_ATTRIB_ARRAY13_NV	   = $865D
GL_VERTEX_ATTRIB_ARRAY14_NV	   = $865E
GL_VERTEX_ATTRIB_ARRAY15_NV	   = $865F
GL_MAP1_VERTEX_ATTRIB0_4_NV	   = $8660
GL_MAP1_VERTEX_ATTRIB1_4_NV	   = $8661
GL_MAP1_VERTEX_ATTRIB2_4_NV	   = $8662
GL_MAP1_VERTEX_ATTRIB3_4_NV	   = $8663
GL_MAP1_VERTEX_ATTRIB4_4_NV	   = $8664
GL_MAP1_VERTEX_ATTRIB5_4_NV	   = $8665
GL_MAP1_VERTEX_ATTRIB6_4_NV	   = $8666
GL_MAP1_VERTEX_ATTRIB7_4_NV	   = $8667
GL_MAP1_VERTEX_ATTRIB8_4_NV	   = $8668
GL_MAP1_VERTEX_ATTRIB9_4_NV	   = $8669
GL_MAP1_VERTEX_ATTRIB10_4_NV	   = $866A
GL_MAP1_VERTEX_ATTRIB11_4_NV	   = $866B
GL_MAP1_VERTEX_ATTRIB12_4_NV	   = $866C
GL_MAP1_VERTEX_ATTRIB13_4_NV	   = $866D
GL_MAP1_VERTEX_ATTRIB14_4_NV	   = $866E
GL_MAP1_VERTEX_ATTRIB15_4_NV	   = $866F
GL_MAP2_VERTEX_ATTRIB0_4_NV	   = $8670
GL_MAP2_VERTEX_ATTRIB1_4_NV	   = $8671
GL_MAP2_VERTEX_ATTRIB2_4_NV	   = $8672
GL_MAP2_VERTEX_ATTRIB3_4_NV	   = $8673
GL_MAP2_VERTEX_ATTRIB4_4_NV	   = $8674
GL_MAP2_VERTEX_ATTRIB5_4_NV	   = $8675
GL_MAP2_VERTEX_ATTRIB6_4_NV	   = $8676
GL_MAP2_VERTEX_ATTRIB7_4_NV	   = $8677
GL_MAP2_VERTEX_ATTRIB8_4_NV	   = $8678
GL_MAP2_VERTEX_ATTRIB9_4_NV	   = $8679
GL_MAP2_VERTEX_ATTRIB10_4_NV	   = $867A
GL_MAP2_VERTEX_ATTRIB11_4_NV	   = $867B
GL_MAP2_VERTEX_ATTRIB12_4_NV	   = $867C
GL_MAP2_VERTEX_ATTRIB13_4_NV	   = $867D
GL_MAP2_VERTEX_ATTRIB14_4_NV	   = $867E
GL_MAP2_VERTEX_ATTRIB15_4_NV	   = $867F

; GLU errors

GLU_INVALID_ENUM	    = 100900
GLU_INVALID_VALUE	    = 100901
GLU_OUT_OF_MEMORY	    = 100902
GLU_INCOMPATIBLE_GL_VERSION = 100903

; GLU boolean values

GLU_TRUE  = GL_TRUE
GLU_FALSE = GL_FALSE

; Quadric constants

GLU_SMOOTH     = 100000
GLU_FLAT       = 100001
GLU_NONE       = 100002
GLU_POINT      = 100010
GLU_LINE       = 100011
GLU_FILL       = 100012
GLU_SILHOUETTE = 100013
GLU_OUTSIDE    = 100020
GLU_INSIDE     = 100021

; Tesselation constants

GLU_TESS_MAX_COORD	       = 1.0e150
GLU_TESS_WINDING_RULE	       = 100140
GLU_TESS_BOUNDARY_ONLY	       = 100141
GLU_TESS_TOLERANCE	       = 100142
GLU_TESS_WINDING_ODD	       = 100130
GLU_TESS_WINDING_NONZERO       = 100131
GLU_TESS_WINDING_POSITIVE      = 100132
GLU_TESS_WINDING_NEGATIVE      = 100133
GLU_TESS_WINDING_ABS_GEQ_TWO   = 100134
GLU_TESS_BEGIN		       = 100100
GLU_TESS_VERTEX 	       = 100101
GLU_TESS_END		       = 100102
GLU_TESS_ERROR		       = 100103
GLU_TESS_EDGE_FLAG	       = 100104
GLU_TESS_COMBINE	       = 100105
GLU_TESS_BEGIN_DATA	       = 100106
GLU_TESS_VERTEX_DATA	       = 100107
GLU_TESS_END_DATA	       = 100108
GLU_TESS_ERROR_DATA	       = 100109
GLU_TESS_EDGE_FLAG_DATA        = 100110
GLU_TESS_COMBINE_DATA	       = 100111
GLU_TESS_ERROR1 	       = 100151
GLU_TESS_ERROR2 	       = 100152
GLU_TESS_ERROR3 	       = 100153
GLU_TESS_ERROR4 	       = 100154
GLU_TESS_ERROR5 	       = 100155
GLU_TESS_ERROR6 	       = 100156
GLU_TESS_ERROR7 	       = 100157
GLU_TESS_ERROR8 	       = 100158
GLU_TESS_MISSING_BEGIN_POLYGON = GLU_TESS_ERROR1
GLU_TESS_MISSING_BEGIN_CONTOUR = GLU_TESS_ERROR2
GLU_TESS_MISSING_END_POLYGON   = GLU_TESS_ERROR3
GLU_TESS_MISSING_END_CONTOUR   = GLU_TESS_ERROR4
GLU_TESS_COORD_TOO_LARGE       = GLU_TESS_ERROR5
GLU_TESS_NEED_COMBINE_CALLBACK = GLU_TESS_ERROR6

; NURBS constants

GLU_AUTO_LOAD_MATRIX	  = 100200
GLU_CULLING		  = 100201
GLU_SAMPLING_TOLERANCE	  = 100203
GLU_DISPLAY_MODE	  = 100204
GLU_PARAMETRIC_TOLERANCE  = 100202
GLU_SAMPLING_METHOD	  = 100205
GLU_U_STEP		  = 100206
GLU_V_STEP		  = 100207
GLU_PATH_LENGTH 	  = 100215
GLU_PARAMETRIC_ERROR	  = 100216
GLU_DOMAIN_DISTANCE	  = 100217
GLU_MAP1_TRIM_2 	  = 100210
GLU_MAP1_TRIM_3 	  = 100211
GLU_OUTLINE_POLYGON	  = 100240
GLU_OUTLINE_PATCH	  = 100241
GLU_NURBS_ERROR1	  = 100251
GLU_NURBS_ERROR2	  = 100252
GLU_NURBS_ERROR3	  = 100253
GLU_NURBS_ERROR4	  = 100254
GLU_NURBS_ERROR5	  = 100255
GLU_NURBS_ERROR6	  = 100256
GLU_NURBS_ERROR7	  = 100257
GLU_NURBS_ERROR8	  = 100258
GLU_NURBS_ERROR9	  = 100259
GLU_NURBS_ERROR10	  = 100260
GLU_NURBS_ERROR11	  = 100261
GLU_NURBS_ERROR12	  = 100262
GLU_NURBS_ERROR13	  = 100263
GLU_NURBS_ERROR14	  = 100264
GLU_NURBS_ERROR15	  = 100265
GLU_NURBS_ERROR16	  = 100266
GLU_NURBS_ERROR17	  = 100267
GLU_NURBS_ERROR18	  = 100268
GLU_NURBS_ERROR19	  = 100269
GLU_NURBS_ERROR20	  = 100270
GLU_NURBS_ERROR21	  = 100271
GLU_NURBS_ERROR22	  = 100272
GLU_NURBS_ERROR23	  = 100273
GLU_NURBS_ERROR24	  = 100274
GLU_NURBS_ERROR25	  = 100275
GLU_NURBS_ERROR26	  = 100276
GLU_NURBS_ERROR27	  = 100277
GLU_NURBS_ERROR28	  = 100278
GLU_NURBS_ERROR29	  = 100279
GLU_NURBS_ERROR30	  = 100280
GLU_NURBS_ERROR31	  = 100281
GLU_NURBS_ERROR32	  = 100282
GLU_NURBS_ERROR33	  = 100283
GLU_NURBS_ERROR34	  = 100284
GLU_NURBS_ERROR35	  = 100285
GLU_NURBS_ERROR36	  = 100286
GLU_NURBS_ERROR37	  = 100287

; Contours types

GLU_CW	     = 100120
GLU_CCW      = 100121
GLU_INTERIOR = 100122
GLU_EXTERIOR = 100123
GLU_UNKNOWN  = 100124
